      PROGRAM INDAS
C******************************************************************************
C     INDAS-Daten fuer einen vorgegebenen Zeitraum lesen und mit gewuenschtem *
C     zeitlichen Abstand im NAK-Format speichern.                             *
C                                                                             *
C     Subr.: INDOLD,INDNEW,TIMEDIF,EDVTIME                                    *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 07.08.1989                                                       *
C******************************************************************************
C
      IMPLICIT DOUBLE PRECISION (D)
C
      REAL *4     SPEED,COURSE,SALZG,TEMPE,EDEPTH,PDEPTH,HDEPTH
      INTEGER*4   LUIN,LUOUT,LUNAK,LUIND
      INTEGER*4   IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI,ISBEGI,IDVSBEGI
      INTEGER*4   IYEND,IMEND,IDEND,IHEND,MIEND,ISEND,IDVSEND
      INTEGER*4   ITIMEDIF
      INTEGER*4   IDDAY,IDTIME, ID2, IM2, IY2, IH2, MI2, IS2
      CHARACTER   WAHL*1, CLS*30, NAKFILN*18, EXCEL*120
      LOGICAL     SWOLD
C
C......COMMON - Block mit den logische Einheiten fuer Ein- und Ausgaben
C
      COMMON /LOG_UNIT/ LUIN,LUOUT,LUIND,LUNAK
      COMMON / FNAME  /  NAKFILN
C
C......Anfangswertzuweisung
C
      SWOLD      = .FALSE.
C
C......logische Units
C
      LUIN       = 5
      LUOUT      = 6
      LUIND      = 10
      LUNAK      = 12
C
C......Bildschirm loeschen
C
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 1111 CONTINUE
      TYPE *, CLS
      WRITE (LUOUT,1001)
 1001 FORMAT (
     *12X,' ******************************************************'/
     *12X,' ************** ALFRED-WEGENER-INSTITUT ***************'/
     *12X,' ********** fuer POLAR- und MEERESFORSCHUNG ***********'/
     *12X,' ******************************************************'/
     *12X,' ********                                      ********'/
     *12X,' ********  II  NN   N  DDDD      A     SSSSSS  ********'/
     *12X,' ********  II  N N  N  D   D    A A    S       ********'/
     *12X,' ********  II  N  N N  D   D   AAAAA   SSSSSS  ********'/
     *12X,' ********  II  N   NN  D   D  AA   AA       S  ********'/
     *12X,' ********  II  N    N  DDDD  AA     AA SSSSSS  ********'/
     *12X,' ********                                      ********'/
     *12X,' ******************************************************'/
     *12X,' ****************************************** FN ********'/
     *12X,' ******************************************************')
C
      WRITE (LUOUT,'(//,1X,A,A)') 'Before running the program ',
     &'there are two logicals to be defined:'
      WRITE (LUOUT,*) 
      WRITE (LUOUT,*) 'INDASDISK as inputdevice and directory'
      WRITE (LUOUT,*) 'DATDISK  as outputdevice and directory'
      WRITE (LUOUT,*) 
      WRITE (LUOUT,*) 'for example:'
      WRITE (LUOUT,*) 'DEFINE INDASDISK DUB1:[INDAS_T]'
      WRITE (LUOUT,*) 
C
C......Beginn der Bearbeitung, Zeit und Datum eingeben
C
      WRITE (LUOUT,'($1X,A)') 
     &'ENTER date and time of first INDAS-file (YY,MM,DD,HH,MM) >'
      READ (LUIN,*) IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI
C
C......Ende der Bearbeitung, Zeit und Datum eingeben
C
      WRITE (LUOUT,'($1X,A)') 
     &'ENTER date and time of last INDAS-file  (YY,MM,DD,HH,MM) >'
      READ (LUIN,*) IYEND,IMEND,IDEND,IHEND,MIEND
C
C......liegen die INDAS-Dateien im alten oder neuen Format vor?
C
      WAHL = ' '
      DO WHILE (WAHL .NE. 'O' .AND. WAHL .NE. 'o' .AND. WAHL .NE. 'N'   
     &.AND. WAHL .NE. 'n')     
         WRITE (LUOUT,'($1X,A)')
     &   'ENTER (o)ld or (n)ew INDAS format (old until summer ''88) >'
         READ (LUIN,'(A)') WAHL
         IF (WAHL .EQ. 'O' .OR. WAHL .EQ. 'o') THEN
            SWOLD = .TRUE.
         ELSE 
            SWOLD = .FALSE.
         END IF
      END DO
C
C......gewuenschter zeitlicher Abstand zwischen den Datensaetzen
C
      WRITE (LUOUT,'($1X,A)') 
     &'ENTER minimal timedifference between 2 outputrecords (s) >'
      READ (LUIN,*) ITIMEDIF
      WRITE (LUOUT,*)
C
C......Bearbeitungszeitraum ermitteln
C
      CALL EDVTIME (IHBEGI,MIBEGI,ISBEGI,IDVSBEGI)
      CALL EDVTIME (IHEND,MIEND,ISEND,IDVSEND)
      CALL TIMEDIF (IDVSBEGI,IDBEGI,IMBEGI,IYBEGI,
     &IDVSEND,IDEND,IMEND,IYEND,IDTIME,IDDAY)
C
      WRITE (LUOUT,*) 'difference between both dates ',IDDAY,' day(s) ',
     &IDTIME,' s'
C
C......Plausibilitaet der Eingaben pruefen, ggf. Programmabbruch
C
      IF (IDTIME .LT. 0 .OR. IDDAY .LT. 0) THEN
         WRITE (LUOUT,'(1X,A)') 
     &   'input ERROR, please check date and time'
         GOTO 999 
      END IF
C
C......altes INDAS-Format
C
      IF (SWOLD) THEN
         CALL INDOLD (IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI,
     &   IYEND,IMEND,IDEND,IHEND,MIEND,ITIMEDIF)
      ELSE
         CALL INDNEW (IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI,
     &   IYEND,IMEND,IDEND,IHEND,MIEND,ITIMEDIF)
      END IF
  999 CONTINUE
      WRITE (LUOUT,'(/A)') '--- INDAS main END ---'
 1234 END
C
C
C
      SUBROUTINE INDOLD (IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI,
     &IYEND,IMEND,IDEND,IHEND,MIEND,ITIMEDIF)
C******************************************************************************
C     INDAS-Daten im alten Format (bis Sommer '88) fuer einen vorgegebenen    *
C     Zeitraum lesen und mit gewuenschtem zeitlichen Abstand im NAK-Format    *
C     speichern.                                                              *
C                                                                             *
C     Subr.: TIMEDIF, EDVTIME, NEXTDAY, MONTHTAB, DECIDEGREE, INDFILOLD       *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 12.06.1989                                                       *
C******************************************************************************
C
      IMPLICIT NONE
C
      INTEGER*4   LUIN,LUOUT,LUNAK,LUIND
      INTEGER*4   IY1,IM1,ID1,IH1,MI1,IS1,IDVS1
      INTEGER*4   IY2,IM2,ID2,IH2,MI2,IS2,IDVS2
      INTEGER*4   IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI,ISBEGI
      INTEGER*4   IYCONT,IMCONT,IDCONT,IHCONT,MICONT,ISCONT
      INTEGER*4   IYEND,IMEND,IDEND,IHEND,MIEND,ISEND
      INTEGER*4   MIDEKC,MIDEKE
      INTEGER*4   ITIMEDIF
      INTEGER*4   IDDAY,IDTIME
      INTEGER*4   ISTATR,ISTATO
      INTEGER*4   IPHIGR,LAMGR
      INTEGER*4   NAVKEN
      REAL   *4   PHIMIN,FLAMMI
      REAL   *4   PHIUN,DLAMUN,DEPTH
      CHARACTER   INDCONT*23,INDEND*23,NAKFILN*18
      CHARACTER   AMONTH*3
      LOGICAL     SWNAK
C
C......COMMON - Block mit den logische Einheiten fuer Ein- und Ausgaben
C
      COMMON /LOG_UNIT/ LUIN,LUOUT,LUIND,LUNAK
      COMMON / FNAME  /  NAKFILN
C
C......Anfangswertzuweisung
C
      INDCONT    = ' '
      INDEND     = ' '
      NAKFILN    = ' ' 
      AMONTH     = ' '
      SWNAK      = .FALSE.
C
C......fuer INDAS-Dateiname
C
      IYCONT = IYBEGI
      IMCONT = IMBEGI
      IDCONT = IDBEGI
      IHCONT = IHBEGI
      MICONT = MIBEGI
      ISCONT = ISBEGI
C
      IY1    = 0
      IM1    = 0
      ID1    = 0
      IH1    = 0
      MI1    = 0
      IS1    = 0
      NAVKEN = 0
C
C......INDAS-Dateinamen bilden
C
      MIDEKC = MICONT / 10     
      WRITE (INDCONT,'(A,I2.2,I1,3(I2.2),A4)')
     &'INDASDISK:',IHCONT,MIDEKC,IDCONT,IMCONT,IYCONT,'.IND'
C
C......wegen Arbeitsschleife den auf die Endedatei folgenden INDAS-Dateinamen
C      bilden
C
      MIDEKE = MIEND / 10     
      CALL INDFILOLD (IHEND,MIDEKE,IDEND,IMEND,IYEND,INDEND) 
C
C......die Schleife wird durchlaufen bis Endedatei erreicht ist
C
  100 CONTINUE 
C
C......INDAS-Datei oeffnen
C
         OPEN (UNIT=LUIND,FILE=INDCONT,STATUS='OLD',IOSTAT=ISTATO,
     &   READONLY)
C
C......Datei vorhanden?
C
         IF (ISTATO .EQ. 0) THEN
            ISTATR = 0
            WRITE (LUOUT,*) INDCONT,' opened'
C
C......INDAS-Datei lesen
C
            DO WHILE (ISTATR .GE. 0)  
C
C......da die INDAS-Dateien am Anfang haeufig mehrere Zeilen *****
C      enthalten
C
  200          CONTINUE
                  READ (LUIND,'(1X,I2,1X,A3,1X,I4,10X,I2,1X,I2,1X,
     &            I2,2X,I4,1X,F6.2,I4,1X,F6.2,20X,F7.1)',IOSTAT=ISTATR)  
     &            ID2,AMONTH,IY2,IH2,MI2,IS2,
     &            IPHIGR,PHIMIN,LAMGR,FLAMMI,DEPTH 
               IF (ISTATR .GT. 0) THEN
                  WRITE (LUOUT,*) 'wrong INDAS record'
                  GOTO 200
               END IF
C
               READ (LUIND,'()',IOSTAT=ISTATR)
               READ (LUIND,'()',IOSTAT=ISTATR)
C
C......da INDAS beim Tageswechsel haeufig im 1. Datensatz das Datum falsch
C      ausgibt (i.d.R. den uebernaechsten Tag) wird beim Tageswechsel generell
C      der 1. Datensatz ueberlesen      
C      hierdurch gibt es nun leider einen Bruch in der Struktur
C      
               IF (ID2 .NE. ID1 .AND. ISTATR .EQ. 0) THEN
                  READ (LUIND,'(1X,I2,1X,A3,1X,I4,10X,I2,1X,I2,1X,
     &            I2,2X,I4,1X,F6.2,I4,1X,F6.2,20X,F7.1)',IOSTAT=ISTATR)  
     &            ID2,AMONTH,IY2,IH2,MI2,IS2,
     &            IPHIGR,PHIMIN,LAMGR,FLAMMI,DEPTH 
                  READ (LUIND,'()',IOSTAT=ISTATR)
                  READ (LUIND,'()',IOSTAT=ISTATR)
               END IF
C
               IF (ISTATR .EQ. 0) THEN
C
C......Monatangabe umcodieren
C
                  CALL MONTHTAB (AMONTH,IM2)
C
C......Phi und Lam in dez. Grad umrechnen
C
                  CALL DECIDEGREE (IPHIGR,PHIMIN,PHIUN)
                  CALL DECIDEGREE (LAMGR,FLAMMI,DLAMUN)
C
C......Jahr um 1900 reduzieren
C
                  IY2 = IY2 - 1900
C
C......Zeitdifferenz berechnen
C
                  CALL EDVTIME (IH1,MI1,IS1,IDVS1)
                  CALL EDVTIME (IH2,MI2,IS2,IDVS2)
                  CALL TIMEDIF (IDVS1,ID1,IM1,IY1,
     &            IDVS2,ID2,IM2,IY2,IDTIME,IDDAY)
C
C......Zeitdifferenz groesser oder gleich Grenzwert
C
                  IF (IDTIME .GE. ITIMEDIF .OR. IDDAY .NE. 0) THEN
C
C......beide Datensaetze vom gleichen Tag?
C
                     IF (ID1 .EQ. ID2 .AND. IM1 .EQ. IM2 .AND. 
     &               IY1 .EQ. IY2) THEN
C
                        WRITE (LUNAK,'(2(1X,I2.2,A,I2.2,A,I2.2),1X,I1,
     &                  1X,F10.5,2X,F10.5,25X,F6.0)') 
     &                  ID2,'-',IM2,'-',IY2,IH2,':',MI2,':',IS2,NAVKEN,
     &                  PHIUN,DLAMUN,DEPTH
C
                        ID1 = ID2
                        IM1 = IM2
                        IY1 = IY2
                        IH1 = IH2
                        MI1 = MI2
                        IS1 = IS2
                     ELSE
C
                        IF (.NOT.SWNAK) THEN
C
C......die 1. NAK-Datei, NAK-Dateinamen bilden und Datei oeffnen
C
                           WRITE (NAKFILN,'(A,3(I2.2),A4)') 
     &                     'DATDISK:',ID2,IM2,IY2,'.DAT'
                           OPEN (UNIT=LUNAK,FILE=NAKFILN,STATUS='NEW')
                           SWNAK = .TRUE.
                           WRITE (LUOUT,*) NAKFILN,'    opened' 
                           WRITE (LUNAK,'(2(1X,I2.2,A,I2.2,A,I2.2),
     &                     1X,I1,1X,F10.5,2X,F10.5,25X,F6.0)') 
     &                     ID2,'-',IM2,'-',IY2,IH2,':',MI2,':',IS2,
     &                     NAVKEN,PHIUN,DLAMUN,DEPTH
C
                           ID1 = ID2
                           IM1 = IM2
                           IY1 = IY2
                           IH1 = IH2
                           MI1 = MI2
                           IS1 = IS2
                        ELSE
C
C......weitere NAK-Dateien
C
                           CLOSE (LUNAK)
                           WRITE (LUOUT,*) NAKFILN,'    closed' 
C
C......NAK-Dateinamen bilden und Datei oeffnen
C
                           WRITE (NAKFILN,'(A,3(I2.2),A4)') 
     &                     'DATDISK:',ID2,IM2,IY2,'.DAT'
                           OPEN (UNIT=LUNAK,FILE=NAKFILN,STATUS='NEW')
                           WRITE (LUOUT,*) NAKFILN,'    opened' 
                           WRITE (LUNAK,'(2(1X,I2.2,A,I2.2,A,I2.2),
     &                     1X,I1,1X,F10.5,2X,F10.5,25X,F6.0)') 
     &                     ID2,'-',IM2,'-',IY2,IH2,':',MI2,':',IS2,
     &                     NAVKEN,PHIUN,DLAMUN,DEPTH
C
                           ID1 = ID2
                           IM1 = IM2
                           IY1 = IY2
                           IH1 = IH2
                           MI1 = MI2
                           IS1 = IS2
                        END IF
                     END IF   
                  END IF   
               END IF
            END DO       
C
C......alte INDAS-Datei schliessen
C
            CLOSE (LUIND)
C
C......naechsten INDAS-Dateinamen bilden
C
            CALL INDFILOLD (IHCONT,MIDEKC,IDCONT,IMCONT,IYCONT,
     &      INDCONT)
C
C......Datei nicht vorhanden
C
         ELSE 
C            WRITE (LUOUT,*) INDCONT,' not found'
C
C......naechsten INDAS-Dateinamen bilden
C
            CALL INDFILOLD (IHCONT,MIDEKC,IDCONT,IMCONT,IYCONT,INDCONT)
         END IF            
C
C......Endedatei erreicht
C
         IF (INDCONT .EQ. INDEND) THEN
            CLOSE (LUNAK)
            WRITE (LUOUT,*) NAKFILN,'    closed' 
            GOTO 999
         END IF
      GOTO 100
  999 CONTINUE
      END
C
C
C
C
      SUBROUTINE INDNEW (IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI,
     &IYEND,IMEND,IDEND,IHEND,MIEND,ITIMEDIF)
C******************************************************************************
C     INDAS-Daten im neuen Format (ab Sommer '88) fuer einen vorgegebenen     *
C     Zeitraum lesen und mit gewuenschtem zeitlichen Abstand im NAK-Format    *
C     speichern.                                                              *
C                                                                             *
C     Subr.: TIMEDIF, EDVTIME, NEXTDAY, MONTHTAB, DECIDEGREE, INDFILNEW,      *
C            READ_IND_NEW, FILENAME                                           *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 20.07.1989                                                       *
C******************************************************************************
C
      IMPLICIT NONE
C
      INTEGER*4   LUIN,LUOUT,LUNAK,LUIND
      INTEGER*4   IY1,IM1,ID1,IH1,MI1,IS1,IDVS1
      INTEGER*4   IY2,IM2,ID2,IH2,MI2,IS2,IDVS2
      INTEGER*4   IYBEGI,IMBEGI,IDBEGI,IHBEGI,MIBEGI,ISBEGI
      INTEGER*4   IYCONT,IMCONT,IDCONT,IHCONT,MICONT,ISCONT
      INTEGER*4   IYEND,IMEND,IDEND,IHEND,MIEND,ISEND
      INTEGER*4   ITIMEDIF
      INTEGER*4   IDDAY,IDTIME
      INTEGER*4   ISTATR,ISTATO
      INTEGER*4   NAVKEN
      REAL   *4   PHIUN,DLAMUN
      REAL   *4   EDEPTH,PDEPTH,HDEPTH
      REAL   *4   SPEED,COURSE,SALZG,TEMPE
      CHARACTER   INDCONT*24,INDEND*24,NAKFILN*18
      LOGICAL     SWNAK
C
C......COMMON - Block mit den logische Einheiten fuer Ein- und Ausgaben
C
      COMMON /LOG_UNIT/ LUIN,LUOUT,LUIND,LUNAK
      COMMON / FNAME  /  NAKFILN
C
C......Anfangswertzuweisung
C
      INDCONT    = ' '
      INDEND     = ' '
      NAKFILN    = ' ' 
      SWNAK      = .FALSE.
C
C......fuer INDAS-Dateiname
C
      IYCONT = IYBEGI
      IMCONT = IMBEGI
      IDCONT = IDBEGI
      IHCONT = IHBEGI
      MICONT = MIBEGI
      ISCONT = ISBEGI
C
      IY1    = 0
      IM1    = 0
      ID1    = 0
      IH1    = 0
      MI1    = 0
      IS1    = 0
C
C......INDAS-Dateinamen bilden
C
      CALL FILENAME (IYCONT,IMCONT,IDCONT,IHCONT,MICONT,INDCONT)
C
C......wegen Arbeitsschleife den auf die Endedatei folgenden INDAS-Dateinamen
C      bilden
C
      CALL INDFILNEW (IHEND,MIEND,IDEND,IMEND,IYEND,INDEND) 
C
C......die Schleife wird durchlaufen bis Endedatei erreicht ist
C
  100 CONTINUE 
C
C......INDAS-Datei oeffnen
C
         OPEN (UNIT=LUIND,FILE=INDCONT,STATUS='OLD',IOSTAT=ISTATO,
     &   READONLY)
C
C......Datei vorhanden?
C
         IF (ISTATO .EQ. 0) THEN
            ISTATR = 0
            WRITE (LUOUT,*) INDCONT,' opened'
C
C......INDAS-Datei lesen
C
            DO WHILE (ISTATR .GE. 0)  
C
C......da die INDAS-Dateien am Anfang haeufig mehrere Zeilen *****
C      enthalten
C
  200          CONTINUE
                  CALL READ_IND_NEW (IY2,IM2,ID2,IH2,MI2,IS2,NAVKEN,
     &            PHIUN,DLAMUN,EDEPTH,PDEPTH,HDEPTH,SPEED,COURSE,
     &            SALZG,TEMPE,ISTATR)        
               IF (ISTATR .GT. 0) THEN
                  WRITE (LUOUT,*) 'wrong INDAS record'
                  GOTO 200
               END IF
C
C......da INDAS beim Tageswechsel haeufig im 1. Datensatz das Datum falsch
C      ausgibt (i.d.R. den uebernaechsten Tag) wird beim Tageswechsel generell
C      der 1. Datensatz ueberlesen      
C      hierdurch gibt es nun leider einen Bruch in der Struktur
C      
               IF (ID2 .NE. ID1 .AND. ISTATR .EQ. 0) THEN
                  CALL READ_IND_NEW (IY2,IM2,ID2,IH2,MI2,IS2,NAVKEN,
     &            PHIUN,DLAMUN,EDEPTH,PDEPTH,HDEPTH,SPEED,COURSE,
     &            SALZG,TEMPE,ISTATR)
               END IF
C
               IF (ISTATR .EQ. 0) THEN
C
C......Zeitdifferenz berechnen
C
                  CALL EDVTIME (IH1,MI1,IS1,IDVS1)
                  CALL EDVTIME (IH2,MI2,IS2,IDVS2)
                  CALL TIMEDIF (IDVS1,ID1,IM1,IY1,
     &            IDVS2,ID2,IM2,IY2,IDTIME,IDDAY)
C
C......Zeitdifferenz groesser oder gleich Grenzwert
C
                  IF (IDTIME .GE. ITIMEDIF .OR. IDDAY .NE. 0) THEN
C
C......beide Datensaetze vom gleichen Tag?
C
                     IF (ID1 .EQ. ID2 .AND. IM1 .EQ. IM2 .AND. 
     &               IY1 .EQ. IY2) THEN
C
                        WRITE (LUNAK,'(2(1X,I2.2,A,I2.2,A,I2.2),
     &                  1X,F10.5,1X,F10.5,2F6.1,
     &                  1X,2F6.2,1X,3(F6.0,1X))') 
     &                  ID2,'-',IM2,'-',IY2,IH2,':',MI2,':',IS2,
     &                  PHIUN,DLAMUN,SPEED,COURSE,
     &                  SALZG,TEMPE,EDEPTH,PDEPTH,HDEPTH
C
                        ID1 = ID2
                        IM1 = IM2
                        IY1 = IY2
                        IH1 = IH2
                        MI1 = MI2
                        IS1 = IS2
                     ELSE
C
                        IF (.NOT.SWNAK) THEN
C
C......die 1. NAK-Datei, NAK-Dateinamen bilden und Datei oeffnen
C
                           WRITE (NAKFILN,'(A,3(I2.2),A4)') 
     &                     'DATDISK:',ID2,IM2,IY2,'.DAT'
                           OPEN (UNIT=LUNAK,FILE=NAKFILN,STATUS='NEW')
                           SWNAK = .TRUE.
                           WRITE (LUOUT,*) NAKFILN,'    opened' 
                           WRITE (LUNAK,'(2(1X,I2.2,A,I2.2,A,I2.2),
     &                     1X,F10.5,1X,F10.5,2F6.1,
     &                     1X,2F6.2,1X,3(F6.0,1X))') 
     &                     ID2,'-',IM2,'-',IY2,IH2,':',MI2,':',IS2,
     &                     PHIUN,DLAMUN,SPEED,COURSE,
     &                     SALZG,TEMPE,EDEPTH,PDEPTH,HDEPTH
C
                           ID1 = ID2
                           IM1 = IM2
                           IY1 = IY2
                           IH1 = IH2
                           MI1 = MI2
                           IS1 = IS2
                        ELSE
C
C......weitere NAK-Dateien
C
                           CLOSE (LUNAK)
                           WRITE (LUOUT,*) NAKFILN,'    closed' 
C
C......NAK-Dateinamen bilden und Datei oeffnen
C
                           WRITE (NAKFILN,'(A,3(I2.2),A4)') 
     &                     'DATDISK:',ID2,IM2,IY2,'.DAT'
                           OPEN (UNIT=LUNAK,FILE=NAKFILN,STATUS='NEW')
                           WRITE (LUOUT,*) NAKFILN,'    opened' 
                           WRITE (LUNAK,'(2(1X,I2.2,A,I2.2,A,I2.2),
     &                     1X,F10.5,1X,F10.5,2F6.1,
     &                     1X,2F6.2,1X,3(F6.0,1X))') 
     &                     ID2,'-',IM2,'-',IY2,IH2,':',MI2,':',IS2,
     &                     PHIUN,DLAMUN,SPEED,COURSE,
     &                     SALZG,TEMPE,EDEPTH,PDEPTH,HDEPTH
C
                           ID1 = ID2
                           IM1 = IM2
                           IY1 = IY2
                           IH1 = IH2
                           MI1 = MI2
                           IS1 = IS2
                        END IF
                     END IF   
                  END IF   
               END IF
            END DO       
C
C......alte INDAS-Datei schliessen
C
C            WRITE (LUOUT,*) INDCONT,' closed'
            CLOSE (LUIND)
C
C......naechsten INDAS-Dateinamen bilden
C
            CALL INDFILNEW (IHCONT,MICONT,IDCONT,IMCONT,IYCONT,INDCONT)
C
C......Datei nicht vorhanden
C
         ELSE 
C            WRITE (LUOUT,*) INDCONT,' not found'
C
C......naechsten INDAS-Dateinamen bilden
C
            CALL INDFILNEW (IHCONT,MICONT,IDCONT,IMCONT,IYCONT,INDCONT) 
         END IF            
C
C......Endedatei erreicht
C
         IF (INDCONT .EQ. INDEND) THEN
            CLOSE (LUNAK)
            WRITE (LUOUT,*) NAKFILN,'    closed' 
            GOTO 999
         END IF
      GOTO 100
  999 CONTINUE
      END
C
C
C
C
      SUBROUTINE EDVTIME (ISTU,MINU,ISEKU,IZEITS) 
C
C******************************************************************************
C     Das Programm rechnet aus Stunden, Minuten und Sekunden die Tageszeit    *
C     in Sekunden                                                             *
C                                                                             *
C     Subr.:                                                                  *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 25.07.1986                                                       *
C******************************************************************************
C
      IZEITS=3600*ISTU+60*MINU+ISEKU
C
      END       
C
C
C
C
      SUBROUTINE TIMEDIF (IZEITA,ITA,MONA,JAHRA,IZEITE,ITE,MONE,JAHRE,
     *                    IDZEIT,IDTAG)
C
C******************************************************************************
C     Das Programm bildet die Differenz zwischen zwei Zeitpunkten.            *
C     Eingabegroessen sind: Zeit in Sekunden, Tag, Monat und Jahr fuer beide  *
C     Zeitpunkte. Die Ausgabe erfolgt in Sekunden und Tagen. Liegt der zweite *
C     Zeitpunkt vor dem ersten Zeitpunkt, werden die Differenzen negativ      *
C     ausgegeben.                                                             *
C                                                                             *
C     Subr.:                                                                  *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 15.07.1986                                                       *
C******************************************************************************
C
      INTEGER MTAG(12)
      LOGICAL SWIT01
C
      SWIT01=.FALSE.
C
C......den Monaten zugehoerige Anzahl Tage zuordnen
C
      MTAG(1)=31
      MTAG(3)=31
      MTAG(4)=30
      MTAG(5)=31
      MTAG(6)=30
      MTAG(7)=31
      MTAG(8)=31
      MTAG(9)=30
      MTAG(10)=31
      MTAG(11)=30
      MTAG(12)=31
      IDTAG=0
C
C......feststellen, ob zweiter Zeitpunkt vor dem ersten Zeitpunkt liegt
C
      IF (JAHRA.GT.JAHRE) THEN
         JAHRH=JAHRA
         JAHRA=JAHRE
         JAHRE=JAHRH
         MONH=MONA
         MONA=MONE
         MONE=MONH
         ITH=ITA
         ITA=ITE
         ITE=ITH
         IZEITH=IZEITA
         IZEITA=IZEITE
         IZEITE=IZEITH      
         SWIT01=.TRUE.
      ELSE IF (JAHRA.EQ.JAHRE.AND.MONA.GT.MONE) THEN
         MONH=MONA
         MONA=MONE
         MONE=MONH
         ITH=ITA
         ITA=ITE
         ITE=ITH
         IZEITH=IZEITA
         IZEITA=IZEITE
         IZEITE=IZEITH      
         SWIT01=.TRUE.
      ELSE IF (JAHRA.EQ.JAHRE.AND.MONA.EQ.MONE.AND.ITA.GT.ITE) THEN
         ITH=ITA
         ITA=ITE
         ITE=ITH
         IZEITH=IZEITA
         IZEITA=IZEITE
         IZEITE=IZEITH      
         SWIT01=.TRUE.
      ELSE IF (JAHRA.EQ.JAHRE.AND.MONA.EQ.MONE.AND.ITA.EQ.ITE
     *   .AND.IZEITA.GT.IZEITE) THEN
         IZEITH=IZEITA
         IZEITA=IZEITE
         IZEITE=IZEITH      
         SWIT01=.TRUE.
      END IF
C
C......feststellen, ob Jahr des ersten Zeitpunkts ein Schaltjahr ist,
C      entsprechende Anzahl Tage dem Februar zuordnen
C
      FJAHR=JAHRA/4.
      IJAHR=4*INT (FJAHR)
      IF ((JAHRA-IJAHR).EQ.0) THEN
         MTAG(2)=29
      ELSE
         MTAG(2)=28
      END IF
C
C......Anzahl der Tage fuer den Monat des ersten Zeitpunkts und den Monat
C      des zweiten Zeitpunkts ermitteln und ggf. addieren
C
      IF (JAHRA.EQ.JAHRE.AND.MONA.EQ.MONE) THEN
         IDTAG=ITE-ITA
      ELSE
         IDTAG=(MTAG(MONA)-ITA)+ITE
      END IF
C
C......aeussere Schleife; wird durchlaufen, wenn die Zeitpunkte
C      in verschiedenen Jahren liegen
C
      DO JAHR=JAHRA,JAHRE
C
C......feststellen, ob lfd. Jahr ein Schaltjahr ist, entsprechende
C      Anzahl Tage dem Februar zuordnen
C
         FJAHR=JAHR/4.
         IJAHR=4*INT (FJAHR)
         IF ((JAHR-IJAHR).EQ.0) THEN
            MTAG(2)=29
         ELSE
            MTAG(2)=28
         END IF
C
C......Zeitraum mit vollen Monaten im lfd. Jahr bestimmen
C
         IF (JAHR.EQ.JAHRA) THEN
             MONAA=MONA+1
         ELSE 
             MONAA=1
         END IF
C
         IF (JAHR.EQ.JAHRE) THEN
             MONEE=MONE-1
         ELSE
             MONEE=12
         END IF
C
C......Summe der Tage fuer die vollen Monate berechnen und zu den Teilmonaten
C      addieren
C
         DO MONAT=MONAA,MONEE
            IDTAG=IDTAG+MTAG(MONAT)
         END DO
C
      END DO
C
C......Differenz der Uhrzeit in Sekunden berechnen
C
      IDZEIT=(86400-IZEITA)+IZEITE
      IF (IDZEIT.GE.86400) THEN
         IDZEIT=IDZEIT-86400
      ELSE
         IDTAG=IDTAG-1
      END IF                
C
C......zweiter Zeitpunkt liegt vor dem ersten Zeitpunkt
C
      IF (SWIT01) THEN
         IDZEIT=-IDZEIT
         IDTAG=-IDTAG
      END IF
C
      END              
C
C
C
C
      SUBROUTINE MONTHTAB (AMON,MONTH)
C******************************************************************************
C     Monatsnamen umkodieren                                                  *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 07.06.1989                                                       *
C******************************************************************************
C
      CHARACTER AMON*3
C
      MONTH=0
C
      IF (AMON.EQ.'JAN') THEN
         MONTH=1
      ELSE IF (AMON.EQ.'FEB') THEN
         MONTH=2
      ELSE IF (AMON.EQ.'MAR') THEN
         MONTH=3    
      ELSE IF (AMON.EQ.'APR') THEN
         MONTH=4
      ELSE IF (AMON.EQ.'MAY') THEN
         MONTH=5
      ELSE IF (AMON.EQ.'JUN') THEN
         MONTH=6
      ELSE IF (AMON.EQ.'JUL') THEN
         MONTH=7
      ELSE IF (AMON.EQ.'AUG') THEN
         MONTH=8
      ELSE IF (AMON.EQ.'SEP') THEN
         MONTH=9
      ELSE IF (AMON.EQ.'OCT') THEN
         MONTH=10
      ELSE IF (AMON.EQ.'NOV') THEN
         MONTH=11
      ELSE IF (AMON.EQ.'DEC') THEN
         MONTH=12
      END IF
      END
C
C
C
C
      SUBROUTINE DECIDEGREE (IGRAD,FMIN,GRDDEC)
C******************************************************************************
C     Aus Grad und Minuten dezimale Grad berechnen                            *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 05.06.1989                                                       *
C******************************************************************************
C
      IMPLICIT NONE
C
      INTEGER * 4 IGRAD
      REAL    * 4 FMIN,GRDDEC
C
      IF (IGRAD .LT. 0 .OR. FMIN .LT. 0.) THEN
         GRDDEC = REAL (IABS (IGRAD)) + ABS (FMIN) /60.
         GRDDEC = GRDDEC * -1.
      ELSE
         GRDDEC = REAL (IGRAD) + FMIN /60.
      END IF
      END
C
C
C
C       
      SUBROUTINE NEXTDAY (ITA,MONA,JAHRA,ITE,MONE,JAHRE) 
C******************************************************************************
C     Das Programm liest Tag, Monat, Jahr ein und gibt das Datum fuer den     *
C     darauf folgenden Tag aus.                                               *
C                                                                             *
C     Subr.:                                                                  *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 15.07.1986                                                       *
C******************************************************************************
C
      INTEGER MTAG(12)
C
C......Anzahl der Tage den entsprechenden Monaten zuordnen
C
      MTAG(1)=31
      MTAG(3)=31
      MTAG(4)=30
      MTAG(5)=31
      MTAG(6)=30
      MTAG(7)=31
      MTAG(8)=31
      MTAG(9)=30
      MTAG(10)=31
      MTAG(11)=30
      MTAG(12)=31
C
C......feststellen, ob Jahr des ersten Zeitpunkts ein Schaltjahr ist,
C      entsprechende Anzahl Tage dem Februar zuordnen
C
      FJAHR=JAHRA/4.
      IJAHR=4*INT (FJAHR)
      IF ((JAHRA-IJAHR).EQ.0) THEN
         MTAG(2)=29
      ELSE
         MTAG(2)=28
      END IF
C
C......Datum des naechsten Tages berechnen
C
      ITE=ITA+1
      IF (ITE.LE.MTAG(MONA)) THEN
         MONE=MONA
         JAHRE=JAHRA
      ELSE
         ITE=1
         MONE=MONA+1
         IF (MONE.LE.12) THEN
            JAHRE=JAHRA
         ELSE        
            MONE=1
            JAHRE=JAHRA+1
         END IF
      END IF
C
      END
C
C
C
C
      SUBROUTINE INDFILOLD (IH,MIDEKA,ID,IM,IY,IND) 
C******************************************************************************
C     Namen der naechstfolgenden INDAS-Datei bilden, die Daten liegen im      *
C     alten INDAS-Format vor.                                                 *
C                                                                             *
C     Subr.: NEXTDAY                                                          *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 13.06.1989                                                       *
C******************************************************************************
C
      IMPLICIT NONE
C
      INTEGER*4 IH,MIDEKA,ID,IM,IY
      CHARACTER IND*23
C
      IND = ' '
      IF (MIDEKA .EQ. 5) THEN
         MIDEKA = 0
         IF (IH .EQ. 23) THEN
            IH = 0
            CALL NEXTDAY (ID,IM,IY,ID,IM,IY) 
         ELSE
            IH = IH + 1
         END IF
      ELSE
         MIDEKA = MIDEKA + 1
      END IF
C
      WRITE (IND,'(A,I2.2,I1,3(I2.2),A4)')
     &'INDASDISK:',IH,MIDEKA,ID,IM,IY,'.IND'
C
      END
C
C
C
C
      SUBROUTINE READ_IND_NEW (IY,IM,ID,IH,MI,IS,NAVKEN,FLATDE,FLONDE,
     &EDEPTH,PDEPTH,HDEPTH,SPEED,COURSE,SALZG,TEMPE,ISTATU)
C******************************************************************************
C     Einen INDAS Datensatz im neuen Format einlesen. Die gewuenschten Daten  *
C     selektieren und ans HP weitergeben.                                     *
C                                                                             *
C     Subr.: DECIDEGREE, MONTHTAB                                             *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 07.08.1989                                                       *
C******************************************************************************
C
      IMPLICIT NONE
C
      INTEGER*4   LUIN,LUOUT,LUNAK,LUIND
      INTEGER*4   IY,IM,ID,IH,MI,IS
      INTEGER*4   LATGR,LONGR
      INTEGER*4   ISTATU
      INTEGER*4   NAVKEN
      REAL   *4   FLATMI,FLONMI
      REAL   *4   FLATDE,FLONDE
      REAL   *4   EDEPTH,PDEPTH,HDEPTH
      REAL   *4   SPEED,COURSE,SALZG,TEMPE
      CHARACTER   AMON*3,AIDENT*5,ALAT*1,ALON*1
      CHARACTER   INDCONT*14
C
C......COMMON - Block mit den logische Einheiten fuer Ein- und Ausgaben
C
      COMMON /LOG_UNIT/ LUIN,LUOUT,LUIND,LUNAK
C
C......Anfangswertzuweisung
C
      AMON    = ' '
      AIDENT  = ' '
      ALAT    = ' '
      ALON    = ' '
      ISTATU  = 0
      NAVKEN  = 0
C
C......einen Datensatz lesen
C
      READ (LUIND,'(2X,2(I2,1X),2(I2),1X,A3,1X,I2,18X,A5,2(A1,1X,I3,
     &1X,F6.3),X,F5.1,7X,F5.1,7X,F6.1,77X,2F6.2,185X,
     &F7.1,17X,F7.1,624X)', IOSTAT=ISTATU)
     &IH,MI,IS,ID,AMON,IY,AIDENT,ALAT,LATGR,FLATMI,ALON,LONGR,FLONMI,
     &SPEED,COURSE,EDEPTH,SALZG,TEMPE,HDEPTH,PDEPTH
C
C......Monatsangabe umcodieren
C
      CALL MONTHTAB (AMON,IM)
C
C......Ident. fuer Systemposition kodieren
C
C      unbekannt                              = 0
C      ID   = Koppelmessung                   = 1
C      IDR  = Koppelmessung + Radionavigation = 2
C      IDS  = Koppelmessung + Transit         = 3
C      IDRS = Koppelmessung + Radio + Transit = 4
C      IDG  = Koppelmessung + GPS             = 5
C      IDGS = Koppelmessung + Transit + GPS   = 6
C      direkte GPS-Positionen                 = 7  z.Zt. nicht realisiert
C
      IF (AIDENT .EQ. 'ID   ' .OR. AIDENT .EQ. ' ID  ' .OR. AIDENT       
     &.EQ. '  ID ' .OR. AIDENT .EQ. '   ID') THEN
         NAVKEN = 1
      ELSE IF (AIDENT .EQ. 'IDR  ' .OR. AIDENT .EQ. ' IDR ' .OR. AIDENT
     &.EQ. '  IDR') THEN
         NAVKEN = 2
      ELSE IF (AIDENT .EQ. 'IDS  ' .OR. AIDENT .EQ. ' IDS ' .OR. AIDENT
     &.EQ. '  IDS') THEN
         NAVKEN = 3
      ELSE IF (AIDENT .EQ. 'IDRS ' .OR. AIDENT .EQ. ' IDRS') THEN
         NAVKEN = 4
      ELSE IF (AIDENT .EQ. 'IDG  ' .OR. AIDENT .EQ. ' IDG ' .OR. AIDENT
     &.EQ. '  IDG') THEN
         NAVKEN = 5
      ELSE IF (AIDENT .EQ. 'IDGS ' .OR. AIDENT .EQ. ' IDGS') THEN
         NAVKEN = 6
      ELSE
         NAVKEN = 0
      END IF
C
C......Laenge und Breite in dezimale Grad umrechnen
C
      IF (ALAT .EQ. 'S' .OR. ALAT .EQ. 's') THEN
         LATGR  = LATGR * -1
         FLATMI = FLATMI * -1.
      END IF
C
      IF (ALON .EQ. 'W' .OR. ALON .EQ. 'w') THEN
         LONGR  = LONGR * -1
         FLONMI = FLONMI * -1.
      END IF
C
      CALL DECIDEGREE (LATGR,FLATMI,FLATDE)
      CALL DECIDEGREE (LONGR,FLONMI,FLONDE)
C
      END
C
C
C
C
      SUBROUTINE INDFILNEW (IH,MI,ID,IM,IY,IND) 
C******************************************************************************
C     Den Namen der naechstfolgenden INDAS-Datei bilden, die Daten liegen     *
C     im neuen INDAS-Format vor.                                              *
C                                                                             *
C     Subr.: NEXTDAY                                                          *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 20.07.1989                                                       *
C******************************************************************************
C
      IMPLICIT NONE
C
      INTEGER*4 IH,MI,ID,IM,IY
      CHARACTER IND*24
C
      IND = ' '
      IF (MI .EQ. 59) THEN
         MI = 0
         IF (IH .EQ. 23) THEN
            IH = 0
            CALL NEXTDAY (ID,IM,IY,ID,IM,IY) 
         ELSE
            IH = IH + 1
         END IF
      ELSE
         MI = MI + 1
      END IF
C
C......INDAS-Dateinamen bilden
C
      CALL FILENAME (IY,IM,ID,IH,MI,IND)
C
      END
C
C
C
C
      SUBROUTINE FILENAME (IY,IM,ID,IH,MI,INDAS) 
C******************************************************************************
C     Den INDAS-Dateinamen bilden. Die Namensaenderung ab August 1989 wird    *
C     ueber das Datum beruecksichtigt.                                        *
C                                                                             *
C     Autor: F. Niederjasper                                                  *
C            Alfred-Wegener-Institut fuer Polar- und Meeresforschung          *
C            D - 2850 Bremerhaven                                             *
C                                                                             *
C     Stand: 20.07.1989                                                       *
C******************************************************************************
C
      IMPLICIT NONE
C
      INTEGER*4 IH,MI,ID,IM,IY
      CHARACTER INDAS*24
C
      INDAS = ' '
C
C......Bearbeitungszeitraum vor oder nach Sommer 1989? Ab August 1989 
C      bekommen die INDAS-Dateien den Namen: MMDDhhmm.IYY
C
      IF ((IY .EQ. 89 .AND. IM .GE. 8) .OR. (IY .GT. 89)) THEN
         WRITE (INDAS,'(A,4(I2.2),A2,I2.2)') 
     &   'INDASDISK:',IM,ID,IH,MI,'.I',IY
      ELSE
         WRITE (INDAS,'(A,5(I2.2),A4)') 
     &   'INDASDISK:',IY,IM,ID,IH,MI,'.IND'
      END IF
C
      END