C     SEDAN - Unterprogramme
C==============================================================================
      SUBROUTINE MACFORM (EXCF, MACF, KP, IMAC)
C
C     EXCF:IN(String)            MACF:OUT(String)
C     KP:IN(Komma oder Punkt)    IMAC:OUT(Anzahl Zeichen)
C     ersetzt Leerzeichen durch TAB und Punkt durch Komma
C
      CHARACTER EXCF*1000, MACF*1000, KP*1
C
      MACF = ' '
C
C.....Leerzeichen durch TAB ersetzen
      ITAB = 1
      IMAC = 0
      LSTRING = NZEICH(EXCF)
      DO I = 1, LSTRING
         IF (EXCF(I:I) .EQ. ' ') THEN
            IF (ITAB .EQ. 0) THEN
               IMAC = IMAC + 1
               MACF(IMAC:IMAC) = '	'
               ITAB = 1
            END IF
         ELSE
            IMAC = IMAC + 1
            MACF (IMAC:IMAC) = EXCF(I:I)
C
C.....Punkte durch Komma ersetzen
            IF (KP .EQ. 'K') THEN
               IF (MACF(IMAC:IMAC) .EQ. '.') MACF(IMAC:IMAC) = ','
            END IF
            ITAB = 0
         END IF
      END DO
      END
C==============================================================================
      SUBROUTINE PARSV ( INPUT,PAR,ZAHL )
C
C     Lesen einer Realvariablen aus einem Characterstring
C---------------------------------------------------------------------
C     input  - Eingabefeld CHARACTER (variable Laenge), sollte Leerzeichen
C               enthalten
C     nc     - Anzahl Zeichen in INPUT
C     par    - Realparameter
C     zahl   - Logische Variable: .true, wenn eine Zahl in Input gefunden
C               wurde
C---------------------------------------------------------------------
C      3:29 PM  FRI.,  7  JUNE, 1985 , Volkhard Spiess , RUB/GUB   (1)
C---------------------------------------------------------------------
      IMPLICIT INTEGER*2 (I-N), REAL*4 (A-H,O-Z)
C
      LOGICAL ZAHL
C
      CHARACTER*(*) INPUT
      CHARACTER*1   KCHAR,KCHARA
      CHARACTER*9   FORM
C
      DATA FORM / '         ' /
C--Logische Variable 
      ZAHL = .FALSE.
C--
      NC = LEN ( INPUT )
C
      INUM  = 1
      IREAL = 0
      IDEZ  = 0
      IEX   = 0
      IBLANK= 1
C
C--Pruefen der Zeichen   INUM = 1 : nur numerische Zeichen ( 0-9,+,- )
C                        IREAL= 1 : zusaetzlich 'E' oder '.'
C                        IDEZ     : Position des Dez.punktes ( 0=keiner )
C                        IEX      : Position des Exp.zeichen ( 0=keins )
C
      KCHAR = CHAR ( 0 )
      NG = NC
C
      DO 30 J = 1,NC
C
        KCHARA= KCHAR
        KCHAR = INPUT(J:J)
C--Leerzeichen: weiter
        IF ( KCHAR.EQ.' ' ) GOTO 30
        NG     = J
        IBLANK = 0
C
C--numerisches Zeichen zwischen 0 und 9 gefunden
        IF ( LGE(KCHAR,'0') .AND. LLE(KCHAR,'9') ) GOTO 30
C--Vorzeichen gefunden
        IF ( KCHAR.EQ.'-' .OR.KCHAR.EQ.'+' ) THEN
          IF ( J     .EQ. 1  ) GOTO 30
          IF ( KCHARA.EQ.'E' ) GOTO 30
        ENDIF
C--Von den uebrig bleibenden Zeichen sind nur noch . und E erlaubt,
C  sonst wird inum=0 gesetzt
        IF ( KCHAR.NE.'.' .AND. KCHAR.NE.'E' ) GOTO 31
C
        IF ( INUM.EQ.1 ) THEN
          IF ( KCHAR.EQ.'.' .OR. (KCHAR.EQ.'E'.AND.J.GT.1) ) IREAL=1
        ENDIF
C
        IF ( IREAL.NE.1 ) GOTO 31
        IF ( KCHAR.EQ.'.' ) IDEZ = J
        IF ( KCHAR.EQ.'E' ) IEX  = J
        GOTO 30
C
31      CONTINUE
        INUM = 0
30    CONTINUE
C----------------------------
C--Keine numerische Variable?
      IF ( INUM.EQ.0 .OR. IBLANK.EQ.1 ) GOTO 90
C-------------------------------------
C--Formatdefinition und Lesen der Zahl
      FORM(1:1) = '('
      IFO       = 2
C--F/E-Format
      FORM(IFO:IFO) = 'F'
      IF ( IEX.NE.0 ) FORM(IFO:IFO) = 'E'
C--Dezimalstellen/Laenge des Exponenten
      NNK = 0
      IF ( IDEZ.GT.0 ) THEN
        IF ( IEX.EQ.0 ) THEN
          NNK = NG - IDEZ 
        ELSE
          NNK = IEX - IDEZ - 1
        ENDIF
      ENDIF
      WRITE ( FORM(IFO+1:),'(I2.2,A,I2.2,A)',ERR=90 ) NG,'.',NNK,')'
      IFO = IFO + 6
C--------------------------------------------------------
C--Decodieren des Eingabestrings mit dem erzeugten Format
CCC      WRITE ( 6,* ) FORM(:IFO)
      READ ( INPUT,FORM(1:IFO),ERR=90 ) RE
C--Zuweisung auf UP-Parameter, falls kein Fehler aufgetreten ist
      PAR  = RE
      ZAHL = .TRUE.
      RETURN
C--------------------------------------------------
C--Dieser Label wird nur im Fehlerfall angesprungen
90    CONTINUE
      ZAHL = .FALSE.
      RETURN
      END
C==============================================================================
      SUBROUTINE TIMER(KERN)        ! berechnet aequidistante Zeiten
C
C Philip J. Howell, Brown University, modified for VAX/SEDAN by H. Grobe, AWI
C----------------------------------------------------------------------------
      PARAMETER (NPAR=400)
      REAL*8 A(5000),D(5000,6),TIME(5000),DOUT(5000),STEP,FIRST   
      CHARACTER*80 FMAT,DATAFN,OUTFN,DECKFN
      CHARACTER*1 TAB, CG, JN, MAC*100, EXCELH*100,
     *            TIM*5, PAR*5, KERN*6, FOUT*40
      TAB=CHAR(9)
C
C.....Open the data file and read in the data according to proper format.
      OPEN (11, FILE='AGE.DAT', STATUS='OLD')
      IVAR = 1 ! Anzahl Variablen
      N = 1
      READ (11,'(A,X,A)') TIM, PAR
   12 CONTINUE
      READ (11,*, END=112) A(N),(D(N,J),J=1,IVAR)
      N = N+1
      GOTO 12
  112 CONTINUE
      N = N-1			! series length
      FIRST = 0.		! starting time (in kyr)
      STEP  = 1.		! time step value (in kyr)
      WRITE (6,'(/,X,A,I4,/,X,A,F10.4,A,/,X,A,F10.4,A)') 
     &  'TIMER executing with series length = ', N,
     &  '                     starting time = ', FIRST, ' kyear',
     &  '                     time step     = ', STEP, ' kyears'
C
C.....Interpolate the time series and calculate the new series length.
      DO 45 L=1,IVAR
         M=DINT((A(N)-FIRST)/STEP)+1
	 IF (M .GT. 5000) M=5000
	 IF (M .LE. 0) THEN
	    WRITE (6, '(/,X,A)')
     &      'Input start time exceeds the last time data value !'
            CALL RET
            GOTO 999
	 ENDIF
	 TIME(1)=FIRST
	 DO 20 I=1,M-1
	    TIME(I+1)=TIME(I)+STEP
   20    CONTINUE
         DO 30 I=1,M
	    IF (TIME(I) .LT. A(1)) THEN
	       IF ((D(1,L) .EQ. 9999.) .OR. (D(2,L).EQ. 9999.)) THEN
	          DOUT(I) = 9999.0
	       ELSE
	          DOUT(I)=((TIME(I)-A(1))/(A(2)-A(1)))*(D(2,L)-D(1,L))
     &   	   +D(1,L)
	       ENDIF
	       GOTO 30
	    ENDIF
	    DO 25 J=1,N
	       IF (TIME(I) .GE. A(J)) THEN
	          IF (J .EQ. N) THEN
		     IF ((D(N,L).EQ.9999.).OR.(D(N-1,L).EQ.9999.))THEN
          	        DOUT(I) = 9999.0
		     ELSE
		        DOUT(I)=(TIME(I)-A(N))*(D(N,L)-D(N-1,L))/
     &                   (A(N)-A(N-1))+D(N,L)
                     ENDIF
		  ELSE
		     IF ((D(J+1,L).EQ.9999.).OR.(D(J,L).EQ.9999.))THEN
                        DOUT(I)= 9999.0
		     ELSE
		        DOUT(I)=(D(J+1,L)-D(J,L))/(A(J+1)-A(J))
		        DOUT(I)=DOUT(I)*(TIME(I)-A(J))+D(J,L)
		     ENDIF
		  ENDIF
	       ENDIF
   25       CONTINUE
   30    CONTINUE
         DO 35 JJ=1,M
	    D(JJ,L)=DOUT(JJ)
   35    CONTINUE
   45 CONTINUE
      WRITE (6, '(/,X,A,I4)') 'New series length = ', M
      WRITE (6, '(/A)') '$Save data with time ? [Y] '
      READ  (5,'(A)') JN
      CALL CAPS(JN) 
C
C.....Open the output file and write data to it
      OPEN (22, FILE = 'AGE.DAT', STATUS='NEW')
      IF (JN .NE. 'N') WRITE (22,'(A,X,A)') TIM, PAR
      IF (JN .EQ. 'N') WRITE (22,'(A)') PAR
      FOUT='ATK$USER:[GEOLOGIE]'//KERN(1:4)//'.'//KERN(6:6)//'TIME'//PAR
      OPEN (23, FILE = FOUT, CARRIAGECONTROL = 'LIST', STATUS = 'NEW')
      DO 70 I = 1, M                                                       
         IF (JN .NE. 'N') WRITE (22,'(F10.4,X,F10.4)')TIME(I),D(I,IVAR)
         IF (JN .EQ. 'N') WRITE (22,'(F10.4)') D(I,IVAR)
   70 CONTINUE
C
C.....Leerzeichen durch TAB ersetzen
      REWIND (22)
  792 CONTINUE
      EXCELH = ' '
      MAC    = ' '
      READ (22,'(A)', END = 795) EXCELH
      ITAB = 1
      IMAC = 0
C
      LSTRING = NZEICH(EXCELH)
      DO I = 1, LSTRING
         IF (EXCELH(I:I) .EQ. ' ') THEN
            IF (ITAB .EQ. 0) THEN
               IMAC = IMAC + 1
               MAC (IMAC:IMAC) = TAB
               ITAB = 1
            END IF
         ELSE
            IMAC = IMAC + 1
            MAC (IMAC:IMAC) = EXCELH(I:I)
            ITAB = 0
         END IF
      END DO
      WRITE (23,'(A)') MAC(:IMAC)
      GOTO 792
  795 CONTINUE
      CLOSE (11, STATUS = 'DELETE')
      CLOSE (22, STATUS = 'DELETE')
      CLOSE (23)
      WRITE(6,'(/2A)')' Daten stehen in ', FOUT
  999 END                                                               
C==============================================================================
      INTEGER*2 FUNCTION NZEICH ( CH )
C     Anzahl Zeichen in Characterfeld (ohne Blanks am Ende)
C
      IMPLICIT INTEGER*2 (I-N), REAL*4 (A-H,O-Z)
      CHARACTER CH*(*), CC*1
C
      NZEICH = LEN ( CH )
      NZ     = NZEICH
      DO 10 J = NZ,1,-1
        CC = CH(J:J)
        IF ( CC.NE.' ') RETURN
        NZEICH = NZEICH - 1
        IF ( NZEICH.EQ.0 ) RETURN
10    CONTINUE
      END
C******************************************************************************
      SUBROUTINE MIST!AKE
C
      CHARACTER*1 E,A
      WRITE (6, '(/,A)') ' ===================================='
      WRITE (6, '(A)')   ' * !!!  I N P U T    E R R O R  !!! *'
      WRITE (6, '(A)')   ' ===================================='
      E=CHAR(27)
      DO 10 I=1,3
      A=CHAR(7)
      WRITE (6,100) E,'[0m',A
  100 FORMAT (1X,A1,A3,A1)
      DO 20 J=1,8000
      X = (X + 2*5/123.654)*0.0009
   20 CONTINUE
   10 CONTINUE
      CALL RET
      END
C******************************************************************************
      SUBROUTINE PAR(IK)
C
      PARAMETER (NPAR=400, NPRO=1600, NTIEF=25)
      CHARACTER IC*3, PARA(NPAR)*40, JN*1
      INTEGER   KEN(NPAR), ANTI(NTIEF), KPT
      REAL      FELD(NPAR,NPRO), TIEF(NTIEF,NPRO)
      COMMON / FE / FELD, TIEF, KPT, KEN, ANTI
      COMMON / PA / PARA
      IC = ' '
  111 WRITE (6,'(/A)') '$Kennung des Parameters  [EXIT]  > '
      IK = 0
      READ  (5,'(A)') IC
      IF (IC .EQ. ' ') GOTO 123
      READ (IC, *, ERR=111) IK
      IF (IK .GT. NPAR .OR. IK .LE. 0) THEN
  112    WRITE (6,'(/,A)') ' *** Parameter nicht erlaubt ! ***'
         GOTO 111
      END IF
      WRITE (6,'(A,40A,A)') '$Parameter ', PARA(IK), 'OK ?  [J]  > '
      READ  (5,'(A)') JN
      CALL CAPS(JN)
      IF (JN .EQ. 'N') GOTO 111
  123 CONTINUE
      END     
C******************************************************************************
      SUBROUTINE BEGIN(IA)
C
      PARAMETER (NPAR=400, NPRO=1600, NTIEF=25)
      CHARACTER AIN*5
      INTEGER   KEN(NPAR), ANTI(NTIEF), KPT
      REAL      FELD(NPAR,NPRO), TIEF(NTIEF,NPRO)
      COMMON / FE / FELD, TIEF, KPT, KEN, ANTI
C
      IF (KPT .EQ. 0) KPT = 1
      WRITE (6,'(/,X,A,F8.2,A)') 'erste Probe bei :', TIEF(KPT,1), ' m'
  100 CONTINUE
      WRITE (6, '(/,A)') '$Probentiefe in cm ?  (RETURN = Exit) -> '
      READ  (5, '(A)', ERR=100) AIN
      IF (AIN .EQ. ' ') GOTO 124
      READ (AIN, *, ERR=100) IPT
      DO IA = 1, ANTI(KPT)
         IF (IPT .EQ. NINT(TIEF(KPT,IA)*100.)) GOTO 123
      END DO
      WRITE (6, '(/,A)') ' Probe nicht vorhanden !'
      GOTO 100
  124 IA = 99999
  123 END
C******************************************************************************
      SUBROUTINE KENT(KT)
C
      PARAMETER (NPAR=400, NPRO=1600, NTIEF=25)
      INTEGER   KEN(NPAR), ANTI(NTIEF), KPT
      REAL      FELD(NPAR,NPRO), TIEF(NTIEF,NPRO)
      CHARACTER KPTEXT(NTIEF)*50, JSN*1
      COMMON / FE / FELD, TIEF, KPT, KEN, ANTI, KPTEXT, JSN
C
      KT = 0
      IA = 0
      WRITE (6, '(/,A)') ' Vorhandene Probenserien : '
      WRITE (6, '(  A)') ' ------------------------- '
      DO I = 1,NTIEF
         IF (ANTI(I) .NE. 0 ) THEN
            WRITE (6,'(X,I2,2X,A)') I, KPTEXT(I)
            IA = IA + 1
            KT = I
         END IF
      END DO
      IF (IA .EQ. 1) GOTO 123
C
  100 WRITE (6, '(/,A)') '$Kennung der Probenserie > '
      READ (5, '(I4)', ERR=100) KT
      IF (ANTI(KT) .EQ. 0) THEN
         WRITE (6,'(/,A)') ' Zu dieser Kennung ist keine 
     *Probenserie vorhanden !'
         KT = 0
         CALL RET
         GOTO 123
      END IF
  123 END
C******************************************************************************
      SUBROUTINE RET
      CHARACTER*10 CLS
C
      WRITE (6,'(A)') '$--------------------------------------
     *-------------------------------- <Return>'
      READ (5,'(A)') XZY
      CLS = CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      TYPE *, CLS
  123 END
C******************************************************************************
      SUBROUTINE SPLINE(X,Y,N,YP1,YPN,Y2)
      PARAMETER (NMAX=200)
      DIMENSION X(N),Y(N),Y2(N),U(NMAX)
      IF (YP1.GT..99E30) THEN
        Y2(1)=0.
        U(1)=0.
      ELSE
        Y2(1)=-0.5
        U(1)=(3./(X(2)-X(1)))*((Y(2)-Y(1))/(X(2)-X(1))-YP1)
      ENDIF
      DO 11 I=2,N-1
        SIG=(X(I)-X(I-1))/(X(I+1)-X(I-1))
        P=SIG*Y2(I-1)+2.
        Y2(I)=(SIG-1.)/P
        U(I)=(6.*((Y(I+1)-Y(I))/(X(I+1)-X(I))-(Y(I)-Y(I-1))
     *      /(X(I)-X(I-1)))/(X(I+1)-X(I-1))-SIG*U(I-1))/P
11    CONTINUE
      IF (YPN.GT..99E30) THEN
        QN=0.
        UN=0.
      ELSE
        QN=0.5
        UN=(3./(X(N)-X(N-1)))*(YPN-(Y(N)-Y(N-1))/(X(N)-X(N-1)))
      ENDIF
      Y2(N)=(UN-QN*U(N-1))/(QN*Y2(N-1)+1.)
      DO 12 K=N-1,1,-1
        Y2(K)=Y2(K)*Y2(K+1)+U(K)
12    CONTINUE
      END
C******************************************************************************
      SUBROUTINE SPLINT(XA,YA,Y2A,N,X,Y)
      DIMENSION XA(N),YA(N),Y2A(N)
      KLO=1
      KHI=N
1     IF (KHI-KLO.GT.1) THEN
        K=(KHI+KLO)/2
        IF(XA(K).GT.X)THEN
          KHI=K
        ELSE
          KLO=K
        ENDIF
      GOTO 1
      ENDIF
      H=XA(KHI)-XA(KLO)
      IF (H.EQ.0.) PAUSE 'Bad XA input.'
      A=(XA(KHI)-X)/H
      B=(X-XA(KLO))/H
      Y=A*YA(KLO)+B*YA(KHI)+
     *      ((A**3-A)*Y2A(KLO)+(B**3-B)*Y2A(KHI))*(H**2)/6.
      END
C******************************************************************************
      SUBROUTINE CAPS ( CSTRING )
C
C     Umwandlung eines Characterstrings in Grossbuchstaben
C
      CHARACTER CSTRING*(*)
      L = LEN ( CSTRING )
C
      DO 10 J = 1,L
        IF ( LGE(CSTRING(J:J),'a') .AND. LLE(CSTRING(J:J),'z') )
     *    CSTRING(J:J) = CHAR ( IAND ( ICHAR(CSTRING(J:J)),223 ) )
10    CONTINUE
      END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COUNTER(TIEF,KORNZA)
	INCLUDE '($IODEF)'
C
C     allgemeines Zaehlprogramm 
C                                                        H. GROBE, 1987
C----------------------------------------------------------------------
C
C     --Variablen--
      CHARACTER KEY(93)*1, NAME(93)*60, YN*1, FILEN*20, Z*1,
     *          FN*11, EXT*3
        CHARACTER IDEVNM*2, FINDEX*17, CZ*3, FORM*20
C
      INTEGER ANZAHL, KORNZA, RAW(100)
	INTEGER*4 SYS$ASSIGN,SYS$QIOW,IEFN,ISTAT
	INTEGER*2 ICHAN
	BYTE IBUF(2)
      REAL DAT(100)
C
	DATA IDEVNM / 'TT' /,IEFNM / 17 /
C
C----------------------------------------------------------------
	ISTAT=SYS$ASSIGN( IDEVNM,ICHAN,,)
	IF( .NOT.ISTAT )  CALL LIB$STOP(ISTAT)
C
      OPEN (12, FILE='[GROBE]HG.KEY', STATUS='OLD')
      DO I =1,93
         READ (12, '(X,A,3X,A60)') KEY(I), NAME(I)
      END DO
      CLOSE (12)
      DO J=1,100
         RAW(J) = 0
      END DO
      ANZAHL = 0
C------------------------------------------------------------------
C     Zaehlschleife
C------------------------------------------------------------------
      TYPE 34
   34 FORMAT (/,X,'##########################################'/
     *        X,'=========================================='/
     *        X,'------------------------------------------'/
     *        X,'         ***  START COUNTING  ***         '/
     *        X,'------------------------------------------'/
     *        X,'========= type = to stop counting ========'/
     *        X,'##########################################',/)
C-----Taste in Variable Z einlesen---------------------------------
  200 CONTINUE
     	ISTAT=SYS$QIOW(%VAL(IEFN),%VAL(ICHAN),
     &		%VAL(IO$_TTYREADALL.OR.IO$M_NOECHO),,,,
     &		IBUF,%VAL(1),,,, )
	IBUF(1)=IBUF(1).AND."177	
	DECODE(1,221,IBUF) Z
  221	FORMAT( A1 )
C------------------------------------------------------------------
      DO 345 K=1,93
         IF (Z .EQ. '=') GOTO 300
         IF (Z .EQ. KEY(K)) THEN
            IF (NAME(K) .EQ. ' ') THEN
               WRITE (6,'(/,A)') 
     *          ' ******************************************'
               WRITE (6,'(A)')   
     *          ' ************  Key not used ! *************'
               WRITE (6,'(A)') 
     *          ' ******************************************'
               CALL SBELL
               GOTO 200
            END IF
            RAW(K) = RAW(K)+1
            ANZAHL = ANZAHL + 1
            WRITE (6, '(X,A,3X,I4,3X,A60,I4)')
     *            KEY(K), RAW(K), NAME(K), ANZAHL
            IF (ANZAHL .EQ. KORNZA) GOTO 300
            GOTO 200
         END IF
  345 CONTINUE
C------------------------------------------------------------------
  300 CONTINUE
      CALL SBELL
      TYPE 36
   36 FORMAT (/,X,'##########################################'/
     *        X,'=========================================='/
     *        X,'------------------------------------------'/
     *        X,'         ***  STOP  COUNTING  ***         '/
     *        X,'------------------------------------------'/
     *        X,'=========================================='/
     *        X,'##########################################',/)
      CALL SBELL
C----------------------------------------------------------------
C     Daten speichern
C----------------------------------------------------------------
      ISUM = 0
      DO 765 L=1,93
         DAT(L) = 0.0
         IF (NAME(L) .NE. ' ') ISUM = ISUM + RAW(L)
  765 CONTINUE
      IF (ISUM .EQ. 0) GOTO 1234
      NZ = 1
      DO 767 L=1,93
         IF (NAME(L) .NE. ' ') THEN
            DAT(NZ) =  100./ISUM*RAW(L)
            NZ = NZ+1
         END IF
  767 CONTINUE
      WRITE (CZ,'(I3)') NZ
      FORM = '('//CZ//'F7.2)'
      WRITE (11,FORM) TIEF, (DAT(L), L = 1,NZ-1)
 1234 CONTINUE
      END
C*******************************************************************************
      SUBROUTINE SBELL
C
      CHARACTER*1 E,A
      E=CHAR(27)
      DO 10 I=1,2
         A=CHAR(7)
         WRITE (6,'(X,A,A3,A)') E,'[0m',A
   10 CONTINUE
      END
C++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DIANE (IEND, IPART, FILIN, JNN)
C
C-----Deklarationen                            
      CHARACTER*35 FILOUT, JJN*1, CDIR*12, KERN*6, JN*1,
     *             TAG*9, ZEIT*8, FILIN*70, JNN*1
      REAL Y2(4000), PROD(7), F(7), DATEN(15),
     *     X(4000), Y(4000), Y1(4000), GLATT(17), E(500+1,2)
C
      EXTERNAL UPKAN, UNPKI
      REAL UPKAN, UNPKI
      INTEGER*2 IARR(256)         ! INTEGER ARRAY TO READ FILE RECORDS
      COMMON / GRADE / X, Y2, JJN
      DATA  GLATT / .005, .01, .02, .03, .045, .07, .09, .12, .22,
     *              .12, .09, .07, .045, .03, .02, .01, .005 /
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IF (IEND .GT. 1) GOTO 999
      IF (JNN .EQ. 'A') THEN
         WRITE (6,'(A)') 
     *'$Kaolinit-Berechnung aus Chlorit <2>. oder <4>. Ordnung > '
         READ (5,*) KIORD
         WRITE (6,'(A)') '$Kaolinit-Factor (* 3. Ord.) > '
         READ (5,*) FACT
         WRITE (6,'(A)') '$grafische Darstellung  [N]  > '
         READ  (5,'(A)') JJN
         CALL CAPS (JJN)
         GOTO 999
      ELSE IF (JNN .EQ. 'P') THEN
         WRITE (6,'(A)') '$<A>lle oder <E>inzeln ?     > '
         READ  (5,'(A)') JN
         CALL CAPS (JN)
      END IF
C
  999 CONTINUE
      OPEN (11,FILE=FILIN,TYPE='OLD',ACCESS='DIRECT',RECL=128,ERR=7111)
      IF (JNN .EQ. 'A') WRITE (6,'(X,A,I6,2X,A)') 
     *    'XRD-Auswertung: ', IEND, FILIN
      READ  (11'1 , ERR=1234) ( IARR(I), I=1,256 )
      ANGLOW = UPKAN ( IARR(27) )                ! LOWEST ANGLE IN THE FILE
      ANGHIG = UPKAN ( IARR(28) )                ! HIGHEST ANGLE IN THE FILE
      CNTMAX = UNPKI ( IARR(33) )                ! MAX. COUNT VALUE IN THE FILE
 1200 NREC = 2                                   ! FIRST RECORD TO BE READ 
      NRPRV= 0                                   ! PREVIOUS SCAN NUMBER IS 0  
      IG = 1
      Y1(1) = 100.
C..............................................................................
 1250 READ (11'NREC , ERR=1234 ) ( IARR(I), I=1,256 ) 
      SANG   = UPKAN ( IARR(1) )                 ! STARTING ANGLE IN THIS RECORD
      STSIZE = UPKAN ( IARR(2) )                 ! STEPSIZE
      EANG   = UPKAN ( IARR(4) )                 ! ENDING ANGLE
      NR     = IARR(6) .AND. "377                ! SCAN NUMBER
C
      IF ( NR .NE. NRPRV ) THEN 
         X(IG) = SANG
         Y(IG) = UNPKI(IARR(7))
         IG = IG+1
      END IF
 1255 CONTINUE
      NPOINT = ( EANG - SANG ) / STSIZE + 0.5    ! NUMBER OF DATA POINTS
      ANGLE  = SANG
      DO 1260 , I=1,NPOINT                       ! LIST ALL DATA POINTS 
         ANGLE  = ANGLE + STSIZE
         COUNTS = UNPKI ( IARR(6+I) )
         X(IG) = ANGLE
         Y(IG) = COUNTS
         IG = IG+1
 1260 CONTINUE 
      NREC = NREC + 1                           ! READ NEXT RECORD
      GOTO 1250 
C..............................................................................
 1234 CLOSE (11)
      IG = IG-1
C.....Ausreisser eliminieren
      DO I = 1,IG-2
         ZW = (Y(I) + Y(I+2))/2
         IF (Y(I+1) .GT. ZW+100.) Y(I+1) = ZW
      END DO
C.....glaetten ueber 17 Werte
      DO I = 1,8
         Y1(I) = Y(9)
      END DO
      DO I = 1,IG-8
         Y1(I+8) = 0.0
         DO I2 = 1,17
            Y1(I+8) = Y1(I+8)+Y(I+I2-1)*GLATT(I2)
         END DO
      END DO
      IF (IPART .EQ. 2) THEN
         DO I = 1,IG
            Y2(I) = Y1(I)
         END DO
         GOTO 4457
      END IF
C.....Lage des Quarzpiek suchen
      DMAX = 0.0
      DO I5 = 1,IG
         IF (X(I5) .GT. 30.) THEN
            IF (Y1(I5) .GT. DMAX) DMAX = Y1(I5)
         END IF
         IF (X(I5) .GT. 32.) GOTO 4458
      END DO
 4458 CONTINUE
      DO I5 = 1,IG
         IF (Y1(I5) .EQ. DMAX) GOTO 4456
      END DO
 4456 CONTINUE
C.....Spektrum verschieben, nach Quarzpiek korrigiert
      IDIF = NINT((31.040 - X(I5))/STSIZE)
      IF (IDIF .EQ. 0) THEN
         DO I4 = 1,IG
            Y2(I4) = Y1(I4)
         END DO
      ELSE IF (IDIF .GT. 0) THEN
         DO I4 = IDIF,IG
            Y2(I4) = Y1(I4-IDIF)
         END DO
      ELSE IF (IDIF .LT. 0) THEN
         DO I4 = 1,IG+IDIF
            Y2(I4) = Y1(I4-IDIF)
         END DO
      END IF
      IF (JNN .EQ. 'A') GOTO 1500    ! auswerten
C------------------------------------------------------------------------------
C.....plotten
 4457 CONTINUE
      IF (JN  .EQ. 'E') THEN
         CALL LUGRAF (IEND, IOUT)
         WRITE (6,'(X,2A)') 'XRD-Auswertung: ',FILIN
      ELSE IF (JN  .EQ. 'A') THEN
         IF (IEND .EQ. 1) CALL LUGRAF (IEND, IOUT)
         IF (IOUT .EQ. 0) WRITE (6,'(X,2A)') 'XRD-Auswertung: ',FILIN
         IF (IOUT .GT. 2) WRITE (6,'(X,2A)') 'XRD-Auswertung: ',FILIN
         IF (IEND .NE. 1) GOTO 4455
      END IF
      CALL GPRINT(0)
      CALL GOPEN
C.....X-Achse
      CALL BGRAF(25.,20.,223.,150.)
      CALL BTICKM(4)
      CALL BAXLAB(4.,3.,999,999)
      CALL BAXIS(1,X(1),0.,X(IG),'Degree$')
      CALL BGRID(1,0)
C.....zweite X-Achse plotten
      CALL BAXORI(25.,170.)
      CALL BTICKM(2)
      CALL BAXIS(-1,X(1),0.,X(IG),'$')
C.....Y-Achse
      CALL BTICKM(5)
      CALL BAXLAB(4.,3.,999,999)
      IF (IPART .EQ. 1) CALL BAXIS(2,0., 250., 1000.,'Intensity$')
      IF (IPART .EQ. 2) CALL BAXIS(2,0., 250., 1000.,'Intensity$')
      CALL BGRID(0,1)
C.....Daten plotten
 4455 CONTINUE
      IF (IOUT .NE. 7) CALL BLICOL(2)
      CALL BLINE(X,Y2,IG)
      IF (JN .EQ. 'A') GOTO 1112
C.....Beschriftung
      CALL GCHARF ('COMP')
      PP = 183.
      IF (IOUT .EQ. 1 .OR. IOUT .EQ. 2) PP = 160.
      DO ICH = 15,35
         IF (FILIN(ICH:ICH) .EQ. 'D') GOTO 4460
      END DO
 4460 CONTINUE
      CALL GCHAR ('Core$',25.,PP,4.0)
      CALL GCHAR 
     * (FILIN(ICH-6:ICH-3)//'-'//FILIN(ICH-1:ICH-1)//'$',44.,PP,4.0) 
      CALL GCHAR ('X-ray Diffraction Analysis$',145.,PP,3.5)
      CALL GCHAR ('AWI$',238.,PP,3.5)
      CALL GCHAR ('Sample$',80.,PP,4.0)
      CALL GCHAR ('m$',130.,PP,3.0)
      CALL GCHAR 
     * (FILIN(ICH-11:ICH-9)//'.'//FILIN(ICH-8:ICH-7)//'$',105.,PP,4.0)
C
C.....Institut, Datum schreiben
      CALL DATE(TAG)
      CALL GCHARA(90)
      CALL GCHAR ('AWI * SEDAN * '//TAG//'$',251.,20.,1.5)
      CALL GCLOSE
      GOTO 1112
C------------------------------------------------------------------------------
 1500 CONTINUE
C.....Peaks integrieren
C.....Smektit..................................................................
      CALL MIN  (100,160,MIN1SM)
      CALL MIN  (280,360,MIN2SM)
      CALL MAX  (170,239,MAXSME)
      CALL PEAK (MIN1SM,MIN2SM,MIN1SM,MAXSME+10,SMEK)
      IF (SMEK .LE. 0.) SMEK = 1.0
C.....Illit....................................................................
      MIN1IL = MIN2SM
      CALL MIN  (450,550,MIN2IL)
      CALL MAX  (370,450,MAXILL)
      CALL PEAK (MIN1IL,MIN2IL,MAXILL-40,MAXILL,TILL)
      TILL = TILL*2.
      IF (TILL .LE. 0.) TILL = 1.0
C.....Hornblende...............................................................
      CALL MIN  (440,510,MINHB1)
      CALL MIN  (510,560,MINHB2)
      CALL MAX  (MINHB1,MINHB2,MAXHB)
      CALL PEAK (MINHB1,MINHB2,MAXHB-12,MAXHB+12,HORN)
      IF (HORN .LE. 0.) HORN = 1.0
C.....Chlorit 2.Ordnung........................................................
      CALL MIN  (480,600,MIN1C2)
      CALL MIN  (640,700,MIN2C2)
      CALL MAX  (600,650,MAXCH2)
      CALL PEAK (MIN1C2,MIN2C2,MAXCH2,MAXCH2+25,CHLO2)
      CHLO2 = CHLO2*2.
      IF (CHLO2 .LE. 0.) CHLO2 = 1.0
C.....Molybdaensulfid..........................................................
      MIN1MO = MIN2C2
      CALL MIN  (750,820,MIN2MO)
      CALL MAX  (MIN1MO,MIN2MO,MAXMO)
      CALL PEAK (MIN1MO,MIN2MO,MAXMO-20,MAXMO+20,STAND)
C.....Illit 2. Ordnung.........................................................
      CALL MIN  (890,910,MIN1I2)
      CALL MIN  (930,970,MIN2I2)
      CALL MAX  (920,950,MAXIL2)
      CALL PEAK (MIN1I2,MIN2I2,MAXIL2-12,MAXIL2,TILL2)
      TILL2 = TILL2*2.
      IF (TILL2 .LE. 0.) TILL2 = 1.0
C.....Chlorit 3.Ordnung........................................................
      CALL MIN  (845,900,MIN1C3)
      CALL MIN  (1000,1040,MIN2C3)
      CALL MAX  (950,1000,MAXCH3)
      CALL PEAK (MIN1C3,MIN2C3,MAXCH3,MAXCH3+17,CHLO3)
      CHLO3 = CHLO3*2.
      IF (CHLO3 .LE. 0.) CHLO3 = 1.0
C.....Quarz 35 ................................................................
      CALL MIN  (1050,1120,MI1Q35)
      CALL MIN  (1130,1160,MI2Q35)
      CALL MAX  (1110,1140,MAXQ35)
      CALL PEAK (MI1Q35,MI2Q35,MAXQ35-13,MAXQ35,QU35)
      QU35 = QU35*2.
      IF (QU35 .LE. 0.) QU35 = 1.0
C.....Chlorit 4.Ordnung........................................................
      CALL MIN  (1320,1340,MIN1C4)
      CALL MIN  (1370,1415,MIN2C4)
      CALL MAX  (MIN1C4, MIN2C4,MAXC4)
      CALL PEAK (MIN1C4,MIN2C4,MAXC4-20,MAXC4+20,CHLO4)
      IF (CHLO4 .LE. 0.) CHLO4 = 1.0
C.....Quarz....................................................................
      CALL MIN  (1380,1420,MINQU1)
      CALL MIN  (1460,1500,MINQU2)
      CALL MAX  (MINQU1,MINQU2,MAXQU)
      CALL PEAK (MINQU1,MINQU2,MAXQU-30,MAXQU,QUARZ)
      QUARZ = QUARZ*2.
C.....Feldspat.................................................................
      MINFE1 = MINQU2
      CALL MIN  (1530,1560,MINFE2)
      CALL MIN  (1560,1585,MINTAL)
      CALL PEAK (MINFE1,MINTAL,MINFE1,MINFE2-2,FELDS)
      IF (FELDS .LE. 0.) FELDS = 1.0
C.....Talc.....................................................................
      CALL MAX  (MINFE2,MINTAL,MAXTAL)
      CALL PEAK (MINFE1,MINTAL,MAXTAL,MAXTAL+20,TALC)
      IF (TALC .LE. 0.) TALC = 1.0
      TALC = TALC*2.
C.....Chlorit 5.Ordnung........................................................
      CALL MIN  (1700,1730,MIN1C5)
      CALL MIN  (1750,1800,MIN2C5)
      CALL MAX  (1720,1770,MAXCH5)
      CALL PEAK (MIN1C5,MIN2C5,MAXCH5-20,MAXCH5,CHLO5)
      CHLO5 = CHLO5*2.
      IF (CHLO5 .LE. 0.) CHLO5 = 1.0
C------------------------------------------------------------------------------
C.....Kaolinit berechnen
      IF (KIORD .EQ. 2) RKAOL  = CHLO2-(CHLO3*FACT)
      IF (KIORD .EQ. 4) RKAOL  = CHLO4-(CHLO3*FACT)
      IF (RKAOL .LT. 0.0) RKAOL = 0.0
C
C.....Prozente berechnen
      TONSUM  = SMEK + TILL*4. + (CHLO3*5.)*2. + RKAOL*2.
         PSMEK  = 100./TONSUM* SMEK
         PTILL  = 100./TONSUM* TILL*4.
         PCHLO  = 100./TONSUM*(CHLO3*5.)*2.
         PKAOL  = 100./TONSUM* RKAOL*2.
C
      TONSUM  = SMEK + TILL + CHLO3*5. + RKAOL + TALC
         PTALC  = 100./TONSUM*TALC
         IF (PTALC .LE. 0.) PTALC = .01
C
      DETSUM  = HORN + QUARZ + FELDS
         PHORN  = 100./DETSUM*HORN
         PQUARZ = 100./DETSUM*QUARZ
         PFELD  = 100./DETSUM*FELDS
C
C.....Verhaeltnisse berechnen
      VSMCH  = SMEK/CHLO2
      VSMIL  = SMEK/TILL
      VSMIC  = SMEK/(TILL+CHLO2)
      VCHIL  = CHLO2/TILL
      VCHTA  = CHLO2/TALC
      IF (VCHTA .GT. 100.) VCHTA = 100.
      VQUAM  = QUARZ/HORN
      VQUFE  = QUARZ/FELDS
      IF (VQUFE .GT. 9999.) VQUFE = 9999.
C
      VC2C3 = CHLO2/CHLO3
      IF (VC2C3 .GT. 20.) VC2C3 = 20.
      VC2C4 = CHLO2/CHLO4
      IF (VC2C4 .GT. 20.) VC2C4 = 20.
      VC2C5 = CHLO2/CHLO5
      IF (VC2C5 .GT. 20.) VC2C5 = 20.
      VI1I2 = TILL/TILL2
      IF (VI1I2 .GT. 50.) VI1I2 = 50.
C
C.....Rohdaten
      WRITE (6, '(X, 8F8.0)') SMEK, TILL, HORN, CHLO2, STAND, TILL2,
     *                        CHLO3, QU35
      WRITE (6, '(X, 6F8.0)') CHLO4, QUARZ, FELDS, TALC, CHLO5, RKAOL
      WRITE (77,'(X, 8F8.0)') SMEK, TILL, HORN, CHLO2, STAND, TILL2,
     *                        CHLO3, QU35
      WRITE (77,'(X, 6F8.0)') CHLO4, QUARZ, FELDS, TALC, CHLO5, RKAOL
C.....Prozente
      WRITE (6 ,'(X, 8F8.2)') PSMEK, PTILL, PCHLO, PKAOL, PTALC,
     *                        PHORN, PQUARZ, PFELD
      WRITE (77,'(X, 8F8.2)') PSMEK, PTILL, PCHLO, PKAOL, PTALC,
     *                        PHORN, PQUARZ, PFELD
C.....Verhaeltnisse
      WRITE (6 ,'(X,11F8.2)') VSMCH, VSMIL, VSMIC, VCHIL, VCHTA,
     *                        VQUAM, VQUFE, VC2C3, VC2C4, VC2C5, VI1I2
      WRITE (77,'(X,11F8.2)') VSMCH, VSMIL, VSMIC, VCHIL, VCHTA,
     *                        VQUAM, VQUFE, VC2C3, VC2C4, VC2C5, VI1I2
C
 1112 CONTINUE
      IF (JN .EQ. 'A' .AND. IEND .EQ. 99999) THEN
         CALL GCHAR ('Core$',25.,183.,4.0)
         CALL GCHAR 
     * (FILIN(ICH+5:ICH+8)//'-'//FILIN(ICH+10:ICH+10)//'$',44.,183.,4.0) 
         CALL GCHAR ('X-ray Analysis$',160.,183.,3.5)
         CALL GCHAR ('AWI$',250.,183.,3.5)
C
C.....Institut, Datum schreiben
         CALL DATE(TAG)
         CALL TIME(ZEIT)
         CALL GCHARA(90)
         CALL GCHAR ('SEDAN * Alfred Wegener Institute for
     * Polar and Marine Research$',251.,20.,1.5)
         CALL GCHARA(90)
         CALL GCHAR (' * '//TAG//' * '//ZEIT//'$',251.,81.,1.5)
         CALL GCLOSE
      END IF
      GOTO 12345
C
C.....wenn Rohdatenfile nicht vorhanden schreibe 9999.
 7111 WRITE (6,'(X,3A)') 'File ', FILIN, ' nicht vorhanden !'
C.....Rohdaten
      WRITE (6, '(X, 8F8.0)') 9999., 9999., 9999., 9999., 9999., 9999.,
     *                        9999., 9999.
      WRITE (6, '(X, 6F8.0)') 9999., 9999., 9999., 9999., 9999., 9999.
      WRITE (77,'(X, 8F8.0)') 9999., 9999., 9999., 9999., 9999., 9999.,
     *                        9999., 9999.
      WRITE (77,'(X, 6F8.0)') 9999., 9999., 9999., 9999., 9999., 9999.
C.....Prozente
      WRITE (6 ,'(X, 8F8.2)') 9999., 9999., 9999., 9999., 9999., 9999.,
     *                        9999., 9999.
      WRITE (77,'(X, 8F8.2)') 9999., 9999., 9999., 9999., 9999., 9999.,
     *                        9999., 9999.
C.....Verhaeltnisse
      WRITE (6 ,'(X,11F8.2)') 9999., 9999., 9999., 9999., 9999., 9999.,
     *                        9999., 9999., 9999., 9999., 9999.
      WRITE (77,'(X,11F8.2)') 9999., 9999., 9999., 9999., 9999., 9999., 
     *                        9999., 9999., 9999., 9999., 9999.
12345 END
C******************************************************************************
      REAL FUNCTION UPKAN (IPKAN)
C
      INTEGER*2 IPKAN                                    ! PACKED ANGLE VALUE
      UPKAN = 0.005 * IPKAN
      IF (IPKAN .GE. 0) GOTO 9000
      UPKAN = - UPKAN - 0.0025
 9000 END
C******************************************************************************
      REAL FUNCTION UNPKI (IPACK)
C
      INTEGER*2 IPACK                   ! CONTAINS THE INTENSITY TO BE UNPACKED
      REAL R                            ! TEMPORARY VALUE
      IF ( IPACK .LT. -1000 ) GOTO 2000
      IF ( IPACK .EQ. 0 ) IPACK = 1     ! PREVENT THAT UNPKI CAN BE  0
      UNPKI = ( FLOAT(IPACK) /10 )**2 * ISIGN(1,IPACK)
      GOTO 3000
 2000 R = FLOAT( IPACK .AND. "77777 ) + 32768.  
      UNPKI = (R/10.) **2
 3000 END
C******************************************************************************
      SUBROUTINE PEAK (IREG1,IREG2,IFLA1,IFLA2,FLAECH)
C
      CHARACTER JJN*1
      REAL X(4000), Y2(4000), XP(5), A(500,2), B(2,2), C(2)
      COMMON / GRADE / X, Y2, JJN
C
      IF (JJN .NE. 'J') GOTO 10
      CALL GROUTE ('SEL MT41XX;EX')
      CALL GPRINT(0)
      CALL GOPEN
C.....X-Achse
      CALL BGRAF(25.,20.,210.,150.)
      CALL BAXLAB(4.,3.,999,999)
      CALL BAXIS(1,X(IREG1-20),0.,X(IREG2+20),'Degree$')
C.....Y-Achse
      CALL MAX(IREG1,IREG2,NMAX)
      CALL BAXLAB(4.,3.,999,999)
      CALL BAXIS(2,0.,50.,Y2(NMAX)+30.,'Intensity$')
C
   10 CONTINUE
      A(1,1) = X(IREG1)
      A(1,2) = Y2(IREG1)
      A(2,1) = X(IREG2+1)
      A(2,2) = Y2(IREG2+1)
C
      FLAECH = 0.0
      DO 100 I=1,2
         C(I)=0.0
         DO 101 J=1,2
            B(I,J)=0.0
  101     CONTINUE
  100 CONTINUE
C
      DO 102 I=1,2
         XP(1)=1.0
         DO 103 J=2,2
            XP(J)=XP(J-1)*A(I,1)
  103    CONTINUE
         DO 104 J=1,2
            DO 105 K=1,2
               B(J,K)=B(J,K)+XP(J)*XP(K)
  105       CONTINUE   
            C(J)=C(J)+XP(J)*A(I,2)
  104    CONTINUE
  102 CONTINUE
C
      CALL SLE(B,C,2,2,1.0E-06)
C
      IF (JJN .EQ. 'J') THEN
         DO I = IREG1-20, IREG2+20
            CALL BRXYV(X(I),Y2(I),XN,YN)
            CALL GDOT (XN,YN,1)
         END DO       
      END IF
      X1=X(IFLA1)
      DX=X(2)-X(1)
      DO 110 I = IFLA1, IFLA2
         XXP=1.0
         YYP=0.0
         DO 111 J=1,2  ! IORD1
            YYP=YYP+XXP*C(J)    
            XXP=XXP*X1
  111    CONTINUE
         IF (YYP .GT. Y2(I)) YYP = Y2(I)
         FLAECH = FLAECH + (Y2(I)-YYP)
         IF (Y2(I) .EQ. Y2(NMAX)) BCKGR = YYP
         IF (JJN .EQ. 'J') THEN
            CALL BRXYV(X(I),Y2(I),XN,YN)
            CALL BRXYV(X(I),YYP,XN,YNN)
            CALL GWICOL(.1,3)
            CALL GVECT(XN,YN,0)
            CALL GVECT(XN,YNN,1)
         END IF
         X1=X1+DX
  110 CONTINUE
      FLAECH = FLAECH - ((Y2(NMAX) - BCKGR)/2.)
      IF (JJN .NE. 'J') GOTO 12345
      CALL GWICOL(.1,2)
      CALL BRXYV(X(IREG1),Y2(IREG1),XN,YN)
      CALL GVECT(XN,YN,0)
      CALL BRXYV(X(IREG2),Y2(IREG2),XN,YN)
      CALL GVECT(XN,YN,1)      
      CALL GCLOSE
12345 END
C******************************************************************************
      SUBROUTINE MAX (IANF, IEND, IMAX)
C
      REAL X(4000), Y2(4000)
      COMMON / GRADE / X, Y2
      YMAX = 0.0
      DO I = IANF, IEND
         IF (Y2(I) .GT. YMAX) THEN
            YMAX = Y2(I)
            IMAX = I
         END IF
      END DO          
      END
C******************************************************************************
      SUBROUTINE MIN (IANF, IEND, IMIN)
C
      REAL X(4000), Y2(4000)
      COMMON / GRADE / X, Y2
      YMIN = 3000.
      DO I = IANF, IEND
         IF (Y2(I) .LT. YMIN) THEN
            YMIN = Y2(I)
            IMIN = I
         END IF
      END DO          
      END
C******************************************************************************
      SUBROUTINE LUGRAF (IIN, IOUT)
C
      IF (IIN .GT. 1) GOTO 123
      TYPE *, CHAR(27)//'[2J'//CHAR(27)//'[1;1f'
      WRITE (6,1001)
 1001 FORMAT (//,
     *5X,' ************ GRAFIKAUSGABE ************ '//
     *5X,' Tektronix  Terminal 40XX .......... <0> '/
     *5X,' Tektronix  Terminal 41XX .......... <1> '/
     *5X,' Tektronix  Terminal 42XX .......... <2> '/
     *5X,' Tektronix  Ink-Jet 4696 ........... <3> '/
     *5X,' Tektronix  Ink-Jet 4692 ........... <4> '//
     *5X,' Benson     ThermoTransfer (A4) .... <5> '/
     *5X,' Benson     ThermoTransfer (A3) .... <6> '//
     *5X,' Benson     Elektrostat ............ <7> '/
     *5X,' Benson     PenPlotter ............. <8> '//
     *5X,' HP         PenPlotter ............. <9> '/
     *5X,' Calcomp    PenPlotter ............ <10> '//
     *5X,' PostScript Laserdrucker hoch ..... <11> '/
     *5X,' PostScript Laserdrucker quer ..... <12> '/
     *5X,' REGIS/VT330 ...................... <13> '//
     *5X,' Liste ............................ <14> ')
  120 WRITE (6,'(/,A)') '$     Ausgabegeraet        ==> '
      READ  (5, *, ERR=120) IOUT
  123 CONTINUE
      IF (IOUT .EQ. 0)  CALL GROUTE ('SEL MT40XX;EX')
      IF (IOUT .EQ. 1)  CALL GROUTE ('SEL MT41XX;EX')
      IF (IOUT .EQ. 2)  CALL GROUTE ('SEL MT42XX;EX')
      IF (IOUT .EQ. 3)  CALL GROUTE ('SEL GT4696;EX')
      IF (IOUT .EQ. 4)  CALL GROUTE ('SEL GT4692;EX')
      IF (IOUT .EQ. 5)  CALL GROUTE ('SEL HCPOSTA4;EX')
      IF (IOUT .EQ. 6)  CALL GROUTE ('SEL HCPOSTA3;EX')
      IF (IOUT .EQ. 7)  CALL GROUTE ('SEL HB3036A;EX')
      IF (IOUT .EQ. 8)  CALL GROUTE ('SEL PB13XX;EX')
      IF (IOUT .EQ. 9)  CALL GROUTE ('SEL PHP7550A;EX')
      IF (IOUT .EQ. 10) CALL GROUTE ('SEL PC1044;EX')
      IF (IOUT .EQ. 11) CALL GROUTE ('SEL HPOST;EX')
      IF (IOUT .EQ. 12) CALL GROUTE ('SEL HPOSTP;EX')
      IF (IOUT .EQ. 13) CALL GROUTE ('SEL MREGIS;EX')
      IF (IOUT .EQ. 14) CALL GROUTE ('LIST *')
      END