C WEDF20
CDECK BOUND
      SUBROUTINE BOUND(QHST)
      PARAMETER (NX1 = 1,NY1 = 16)
      DIMENSION QHST(NX1,NY1),SST(NY1),SBT(NY1),SBS(NY1)
      COMMON /PAR/ TF(NX1,NY1)
      COMMON /PML/QS(NX1,NY1),QH(NX1,NY1),QDS(NX1,NY1),QSB(NX1,NY1),QTB
     +(NX1,NY1),QHB(NX1,NY1),QDT(NX1,NY1),QT(NX1,NY1),UMOLD(NX1,NY1),
     +QHSTO(NX1,NY1),MLFIX,MLMOD,POLY,HS(NX1,NY1),HT(NX1,NY1),WUP 
      DATA SST/3.3,2.86,2.42,1.98,1.54,1.1,0.49,-0.12,-0.73,
     +-1.34,-1.90,-1.90,-1.90,-1.90,-1.90,-1.90/
      DATA SBT/3.5,3.3,3.1,2.9,2.7,2.5,2.3,2.1,1.9,1.7,1.5,1.3, 
     *1.1,0.9,0.7,0.5/
      DATA SBS/34.40,34.42,34.44,34.46,34.48,34.50,34.52,34.54, 
     *34.56,34.58,34.60,34.62,34.64,34.66,34.68,34.70/
          CC = 4.2E6
          CL = 3.02E8
      DO 10 J=1,NY1 
        DO 10 I=1,NX1 
C
C         SET BOUNDARY CONDITIONS
C
          QSB(I,J) = SBS(J)+0.05
C     QSB(I,J)=34.7 
          QTB(I,J) = SBT(J) 
C     QTB(I,J)= 0.0 
C     IF(J.LE.5) QTB(I,J)=1.0 
          QHB(I,J) = 3000.0 
C
C         SET INITIAL CONDITIONS
C
      QH(I,J)=22.15 
      IF(MLFIX.EQ.1) QH(I,J)=50.0 
          QS(I,J) = 33.3
      IF(MLFIX.EQ.1) QS(I,J)=33.7 
      QT(I,J)=SST(J)
      TF(I,J)=-0.0575*QS(I,J)+1.710523E-3*QS(I,J)**1.5
     1-2.154996E-4*QS(I,J)**2.0 
          IF (QHST(I,J).GE.0.) QT(I,J) = TF(I,J)
C         IF (QHST(I,J).LT.0) QS(I,J) = 34.0
      IF(SST(J).GT.TF(I,J)) QHST(I,J)=(TF(I,J)-QT(I,J))*CC/CL*QH(I,J) 
          QDS(I,J) = 13.00
          QDT(I,J) = 71.0 
          QHSTO(I,J) = QHST(I,J)
          UMOLD(I,J) = 0.1*0.1*0.1
          IF (MLFIX.EQ.1) QDS(I,J) = 0.0
          IF (MLFIX.EQ.1) QDT(I,J) = 0.0
C 
      HT(I,J)=(QT(I,J)-QTB(I,J))*(QH(I,J)+QDT(I,J))+QTB(I,J)* 
     1QHB(I,J)
      HS(I,J)=(QS(I,J)-QSB(I,J))*(QH(I,J)+QDS(I,J))+QSB(I,J)* 
     1QHB(I,J)
   10 CONTINUE
C
      RETURN
      END
CDECK DEPTH
      SUBROUTINE DEPTH(HH,FH,DERF)
      COMMON /PMLII/QSF,QTF,QWT,QHW,QHS,H1,H2,S1,S2,T1,T2,DS,DT,
     +QDELH,QRHO,BETAS,BETAT,QW 
C
C         EQUILIBRIUM DEPTH OF MIXED LAYER DURING RETREAT
C
      QWD = QW*EXP(-HH/QHW)
      FH = QWD*2.+9.81*QRHO*HH
      DERF = -2.*QWD/QHW+9.81*QRHO
   10 RETURN
      END
CDECK ENBALI
      SUBROUTINE ENBALI(TSTAR,FTS,DERF)
      COMMON /PAR1/ TF1 
      COMMON /YCEC/ ATEMP,OTEMP,WIND,SOLRAD,CLOUDS,PRESS,HICE 
      TFR = 273.16+TF1
      AKAPPA = 2.04
      A = 9.5
      B = 7.66
      SIGMA = 5.67E-8
      EPS = 0.97
      ELE = 2.834E6
      CP = 1004.0
      R = 287.04
      CE = 1.75E-3
      CH = 1.75E-3
      RHOAIR = PRESS/ATEMP/R
C
      FTS = RAD(TSTAR)+FSL(TSTAR)+AKAPPA*(TFR-TSTAR)/(HICE+0.017)
      RT = A*(TSTAR-273.16)/(TSTAR-B)
      ES = 611.0*(10.0**RT)
      DESDTS = ES*ALOG(10.0)*A*(273.16-B)/(TSTAR-B)/(TSTAR-B)
      DQSDES = PRESS*0.622/(PRESS-(1.0-0.622)*ES)**2
      DQSDTS = DQSDES*DESDTS
      DERF = -4.0*EPS*SIGMA*TSTAR*TSTAR*TSTAR-RHOAIR*CP*CH*WIND-AKAPPA/
     +(HICE+0.017)-RHOAIR*ELE*CE*WIND*DQSDTS
      RETURN
      END
CDECK FSL
      REAL FUNCTION FSL(TS)
      COMMON /YCEC/ ATEMP,OTEMP,WIND,SOLRAD,CLOUDS,PRESS,HICE 
      R = 287.04
      RHOAIR = PRESS/ATEMP/R
      CE = 1.75E-3
      CH = 1.75E-3
      CP = 1004.0
      ELE = 2.834E6
      IF (HICE.LE.0.0) ELE = 2.5E6
      FSL = RHOAIR*CP*CH*WIND*(ATEMP-TS)+RHOAIR*ELE*CE*WIND*(0.8*QSP
     +(ATEMP)-QSP(TS))
      RETURN
      END
CDECK PML1
      SUBROUTINE PML1(QHST,QFM,QV,TML)
C
C         POLAR MIXED LAYER (TWO LAYER MODEL)
C
      PARAMETER (NX1 = 1,NY1 = 16)
      DIMENSION FE(5),FV(5)
      DIMENSION TML(NX1,NY1),QFM(NX1,NY1),QHST(NX1,NY1),QV(NX1,NY1)
      COMMON /PML/QS(NX1,NY1),QH(NX1,NY1),QDS(NX1,NY1),QSB(NX1,NY1),QTB
     +(NX1,NY1),QHB(NX1,NY1),QDT(NX1,NY1),QT(NX1,NY1),UMOLD(NX1,NY1),
     +QHSTO(NX1,NY1),MLFIX,MLMOD,POLY,HS(NX1,NY1),HT(NX1,NY1),WUP 
      COMMON /STEP/DELTAT,DELTAX,DELTAY
      COMMON /PAR/ TF(NX1,NY1)
      COMMON /PMLII/QSF,QTF,QWT,QHW,QHS,H1,H2,S1,S2,T1,T2,DS,DT,
     +QDELH,QRHO,BETAS,BETAT,QW 
      EXTERNAL DEPTH
C
C         SET BASIC PARAMETERS
C
      QHW = 10.0
      QHS = 50.0
      QHSMAX=50.0 
      WUP=5.0E-7
      IF(MLFIX.EQ.1) WUP=0. 
      SICE = 5.0
      CW = 0.005
      PI = 3.14159
      GAMMA = 24.0
      DELTAD =8.0 
      BETAS = 0.0008
      BETAT = 0.00004
      EPSAA=1.0E-8
C
C         PRECIPITATION 30 CM/YEAR
C
      QPR = 0.35/364.0/86400.0
      IF(MLFIX.EQ.1) QPR=0. 
C
C         CC=RHO*CP IN JOULE/DEG.C/M**3
C
      CC = 4.2E6
      CL = 3.02E8
C
C
      DO 110 J=1,NY1
        DO 110 I=1,NX1
          H1 = QH(I,J)
          H2 = QHB(I,J)
          DS = QDS(I,J)
          DT = QDT(I,J)
          S1 = QS(I,J)
          S2 = QSB(I,J)
          T1 = QT(I,J)
          T2 = QTB(I,J)
          QOO = QHST(I,J)
          QSF = -QFM(I,J)*(S1-SICE)/DELTAT - QPR*S1 
          QTF = (AMIN1(QHSTO(I,J),0.)-AMIN1(QHST(I,J),0.))*CL/CC/DELTAT
C
            QON = QHST(I,J)
              QRHO = BETAS*QSF-BETAT*QTF
              UM = QV(I,J)
              QW = UM*CW*COS(2.*PI*GAMMA/360.)
              QWT = QW*EXP(-H1/QHW)
      HTOLD=HT(I,J) 
C
C 
C      UPDATE HEAT AND SALT CONTENT 
C 
   10 HS(I,J)=HS(I,J)+QSF*DELTAT + WUP*DELTAT*(S2-S1) 
      HT(I,J)=HT(I,J)+QTF*DELTAT + WUP*DELTAT*(T2-T1) 
C
              IF (MLFIX.NE.1) GO TO 15
C
C         CONSTANT MIXED LAYER
C         QTOC=OCEANIC HEATFLUX IN W/M**2
C
              QTOC = 7.0
              HT(I,J)=HT(I,J)+QTOC/CC*DELTAT
      T1=(HT(I,J)-T2*(H2-H1))/H1
      S1=(HS(I,J)-S2*(H2-H1))/H1
C
              GO TO 34
C         TEST FOR ENTRAINMENT
C
   15         DCV = 1.
              IF (QRHO.GT.0.) DCV = AMAX1(EXP(-QHSMAX/QHS),EXP(-H1/QHS))
              ENT = 2.*QWT+9.81*QRHO*DCV*H1 
              IF (ENT.GT.0.) GO TO 30 
C
C         NO ENTRAINMENT
C
   20         IEN = 0
              HV = H1
C
C         NUMERICAL PARAMETERS FOR RTNI
C
              IENDD = 5000
              EPS = 1.0E-4
              H1E = H1/2.
              CALL RTNI(X1,FX1,DERF,DEPTH,H1E,EPS,IENDD,IER)
C
C         X1=NEW H1
              IF (X1.LT.10.0) X1 = 10.0 
              H1=X1 
      DH1=H1-HV 
C
      HVR=HV
      HVR=2.0*H1*HV/(H1+HV) 
      H1=H1-WUP*DELTAT
C 
      IF(ABS(S2-S1).GT.0.01) S1=S1+QSF*DELTAT/HVR 
      IF(ABS(S2-S1).GT.0.01) DS=(HS(I,J)-S2*H2)/(S1-S2)-H1
      IF(ABS(S2-S1).LE.0.01) DS=DS-DH1
      IF(ABS(S2-S1).LE.0.01) S1=(HS(I,J)-S2*H2)/(H1+DS)+S2
      IF(ABS(T1-T2).GT.1.5) T1=T1+QTF*DELTAT/HVR
      IF(ABS(T1-T2).GT.1.5) DT=(HT(I,J)-T2*H2)/(T1-T2)-H1 
      IF(ABS(T1-T2).LE.1.5) DT=DT-DH1 
      IF(ABS(T1-T2).LE.1.5) T1=(HT(I,J)-T2*H2)/(H1+DT)+T2 
              GO TO 44
C 
C
C         ENTRAINMENT
C
   30         IEN = 1
C 
C
   24         SS = S2-S1
      TT=T2-T1
      ADT=1.-EXP(-DELTAD/DT)
      ADT=1.0+(EXP(-DELTAD/DT)-1.0)*DT/DELTAD 
      TTT=TT*ADT
      ADS=1.-EXP(-DELTAD/DS)
      ADS=1.0+(EXP(-DELTAD/DS)-1.0)*DS/DELTAD 
      SSS=SS*ADS
      DCV=1.
      IF(QRHO.GT.0.) DCV=AMAX1(EXP(-QHSMAX/QHS),EXP(-H1/QHS)) 
C     IF(QRHO.GT.0.) DCV=EXP(-H1/QHS) 
      ENT=2.*QW*EXP(-H1/QHW)+9.81*QRHO*DCV*H1 
              DETA = 9.81*H1*(BETAS*SSS-BETAT*TTT)
      AAA=BETAS*SS-BETAT*TT 
              IF(QON.GT.0.) DETA=DETA-9.81*H1*TTT*DCV 
     1        *(BETAT-CC/CL*BETAS*(S1-SICE))
              HV = H1
      DH1=ENT/DETA*DELTAT 
C
              H1 = H1+DH1-WUP*DELTAT
C     IF(AAA.LE.EPSAA) H1=HV+3.0
      IF(DH1.GE.30) WRITE(6,997)  JLAT,S1,S2,T1,T2,H1,DS,DT,QON,ENT,
     1AAA,DETA
  997 FORMAT(1H ,'STRONG ENTRAINMENT',I5,8F7.2,3E11.3)
      IF(DH1.LE.0.)   WRITE(6,999)
      JLAT=J+54 
      IF(AAA.LE.EPSAA) WRITE(6,998)  JLAT,S1,S2,T1,T2,H1,DS,DT,QON,ENT, 
     1AAA,DETA
  998 FORMAT(1H ,'UNSTABLE',I5,8F7.2,3E11.3)
C     IF(DH1.LE.0.) GO TO 120 
  999 FORMAT(1H ,'ERROR') 
C 
      IF(QON.LE.0.) GO TO 29
C     GO TO 29
      QTOC=-TTT*DH1/DELTAT
              QON1=QHST(I,J)
              QHST(I,J)=QHST(I,J)+CC/CL*QTOC*DELTAT 
              QFMO1=AMAX1(QON1,0.)-AMAX1(QHST(I,J),0.)
              QSFO=-QFMO1*(S1-SICE)/DELTAT
      QTFO=QTOC-AMIN1(QHST(I,J),0.)*CL/CC/DELTAT
      QSF=QSF+QSFO
      QTF=QTF+QTFO
              HS(I,J)=HS(I,J)+QSFO*DELTAT 
      HT(I,J)=HT(I,J)+QTFO*DELTAT 
   29 IF(ABS(S2-S1).GT.0.01) S1=S1+QSF*DELTAT/HV+SSS/HV*DH1 
      IF(ABS(S2-S1).GT.0.01) DS=(HS(I,J)-S2*H2)/(S1-S2)-H1
      IF(ABS(S2-S1).LE.0.01) DS=DS-DH1
      IF(ABS(S2-S1).LE.0.01) S1=(HS(I,J)-S2*H2)/(H1+DS)+S2
      IF(ABS(T1-T2).GT.1.5) T1=T1+QTF*DELTAT/HV+TTT/HV*DH1
      IF(ABS(T1-T2).GT.1.5) DT=(HT(I,J)-T2*H2)/(T1-T2)-H1 
      IF(ABS(T1-T2).LE.1.5) DT=DT-DH1 
      IF(ABS(T1-T2).LE.1.5) T1=(HT(I,J)-T2*H2)/(H1+DT)+T2 
C 
C     SIMULATE DIFFUSION FOR DT,DS < 5.0M 
C 
   31         IF (DS.GT.5.0) GO TO 32 
      DS=5.0
      S1=(HS(I,J)-S2*H2)/(H1+DS)+S2 
   32 IF(DT.GT.5.0) GO TO 34
      DT=5.0
      T1=(HT(I,J)-T2*H2)/(H1+DT)+T2 
C 
C***FINAL ADJUSTMENT********************* 
C 
   34         IF(QON.LE.0.) GO TO 44
   35         QTOC=(TF(I,J)-T1)*H1/DELTAT 
              HT(I,J)=HT(I,J)+QTOC*DELTAT 
              QON1=QHST(I,J)
              QHST(I,J)=QHST(I,J)+CC/CL*QTOC*DELTAT 
              QFMO1=AMAX1(QON1,0.)-AMAX1(QHST(I,J),0.)
              QSFO=-QFMO1*(S1-SICE)/DELTAT
              HS(I,J)=HS(I,J)+QSFO*DELTAT 
              HT(I,J)=HT(I,J)-AMIN1(QHST(I,J),0.)*CL/CC 
              T1=TF(I,J)-AMIN1(QHST(I,J),0.)*CL/CC/H1 
              S1=S1+QSFO*DELTAT/H1
C 
      IF(MLFIX.EQ.1) GO TO 44 
C     IF(S1.LT.S2-0.001) GO TO 36 
C     HV=H1 
C     H1=H1+5.0 
C     GO TO 29
C 
   36 DS=(HS(I,J)-S2*H2)/(S1-S2)-H1 
      DT=(HT(I,J)-T2*H2)/(T1-T2)-H1 
C 
C...CHECK IF DS,DT<4M 
C 
C     IF(DS.LE.4.) GO TO 31 
C     IF(DT.LE.4.) GO TO 31 
C 
C 
C*****STABILITY ADJUSTMENT************************************
C 
      STAB=BETAS*(S2-S1)-BETAT*(T2-T1)
      IF(STAB.GE.0.) GO TO 44 
      TF(I,J)=-0.0575*S1+1.710523E-3*S1**1.5
     1-2.154996E-4*S1**2.0
      SSTAR=S2-BETAT/BETAS*(T2-TF(I,J))-0.001 
      SSS=(S2-S1)*(1.+(EXP(-DELTAD/DS)-1.0)*DS/DELTAD)
      TTT=(T2-T1)*(1.+(EXP(-DELTAD/DT)-1.0)*DT/DELTAD)
      HV=H1 
      H1=HV+(S1-SSTAR)*(H1+DS-QON1)/(T2-TF(I,J))/(CC/CL*(SSTAR-SICE)
     1-BETAT/BETAS) 
      QTOC=-(T2-TF(I,J))*(H1-HV)
              HT(I,J)=HT(I,J)+QTOC
              QON1=QHST(I,J)
              QHST(I,J)=QHST(I,J)+CC/CL*QTOC
              QON2=AMAX1(QHST(I,J),0.)
              HS(I,J)=HS(I,J)+QON2*(SSTAR-SICE)-QON1*(S1-SICE)
              HT(I,J)=HT(I,J)-AMIN1(QHST(I,J),0.)*CL/CC 
              T1=TF(I,J)-AMIN1(QHST(I,J),0.)*CL/CC/H1 
              S1=SSTAR
C     DS=(HS(I,J)-S2*H2)/(S1-S2)-H1 
C     DT=(HT(I,J)-T2*H2)/(T1-T2)-H1 
      WRITE(6,992)  T1,S1,H1,DT,DS,QHST(I,J)
  992 FORMAT(1H ,'STABILITY ADJUSTED',14X,10F7.2) 
C 
C 
   44         IF(QON.LE.0.) QHST(I,J)=-(T1-TF(I,J))*H1*CC/CL
C
C  45         CALL VELO(FV) 
C
C  50         S1 = S1+DELTAT*FV(1)
C             T1 = T1+DELTAT*FV(2)
C             H1 = H1+DELTAT*FV(3)
C             DS = DS+DELTAT*FV(4)
C             DT = DT+DELTAT*FV(5)
C 
C 
  100 CONTINUE
C 
  105       QS(I,J) = S1
            QT(I,J) = T1
            QH(I,J) = H1
            QDS(I,J) = DS
            QDT(I,J) = DT
C
          UMOLD(I,J) = UM
          QHSTO(I,J) = QHST(I,J)
          TML(I,J) = T1
          QFM(I,J) =(AMAX1(QOO,0.)-AMAX1(QHST(I,J),0.)) 
C
C         MAINTAIN STABLE DENSITY PROFILES
C
      GO TO 110 
  106 IF(MLFIX.EQ.1) GO TO 110
      STAB=BETAS*(S2-S1)-BETAT*(T2-T1)
          IF (STAB.GE.0.0) GO TO 110
      QSB(I,J)=S1+BETAT/BETAS*(T2-T1)+0.001 
      WRITE(6,991) JLAT,QSB(I,J)
  991 FORMAT(1H ,'STABILITY CORRECTED',I5,F7.2) 
C
C
  110 CONTINUE
  120 RETURN
      END
CDECK QSP
      REAL FUNCTION QSP(T)
      COMMON /YCEC/ ATEMP,OTEMP,WIND,SOLRAD,CLOUDS,PRESS,HICE 
      A = 9.5
      B = 7.66
      IF (HICE.LE.0.0) A = 7.5
      IF (HICE.LE.0.0) B = 35.86
      RT = A*(T-273.16)/(T-B)
      ES = 611.0*(10.0**RT)
      QSP = 0.622*ES/(PRESS-(1.0-0.622)*ES)
      RETURN
      END
CDECK RAD
      REAL FUNCTION RAD(TS)
      COMMON /YCEC/ ATEMP,OTEMP,WIND,SOLRAD,CLOUDS,PRESS,HICE
      SIGMA = 5.67E-8
      EPS = 0.97
      SRD = 0.7*(1.0-0.6*(CLOUDS**3))*SOLRAD
      LRD = EPS*SIGMA*(ATEMP**4)*(1.0+0.275*CLOUDS)*(1.0-0.261*EXP(
     +-0.000777*(273.0-ATEMP)**2))
      IF (HICE.GT.0.0.AND.TS.LT.273.0) ALBEDO = 0.75
      IF (HICE.GT.0.0.AND.TS.GT.273.0) ALBEDO = 0.50
      IF (HICE.LE.0.0)                  ALBEDO = 0.1
      RAD = (1.0-ALBEDO)*SRD+LRD-EPS*SIGMA*TS*TS*TS*TS
      RETURN
      END
CDECK RTNI
      SUBROUTINE RTNI (X,F,DERF,FCT,XST,EPS,IEND,IER)
C         RTNI       FROM NSSL                VERSION   9          08/10/77
C
C
C         LATEST REVISION        DECEMBER 9, 1974
C
C         PURPOSE                TO SOLVE GENERAL NONLINEAR EQUATIONS OF THE
C         FORM F(X) = 0, BY MEANS OF NEWTON(S) ITERATION
C         METHOD.
C
C         ACCESS CARDS           *FORTRAN,S=ULIB,N=RTNI
C         COSY
C
C         USAGE                  CALL RTNI (X,F,DERF,FCT,XST,EPS,IEND,IER)
C
C         ARGUMENTS
C
C         ON INPUT               XST
C         INITIAL GUESS OF THE ROOT X.
C
C         EPS
C         UPPER BOUND OF THE ERROR OF THE RESULT X.
C
C         IEND
C         MAXIMUM NUMBER OF ITERATION STEPS SPECIFIED.
C
C         FCT
C         EXTERNAL SUBROUTINE PROVIDED BY THE USER TO
C         CALCULATE THE FUNCTION VALUE F AND DERIVATIVE
C         DERF AT GIVEN X.  MUST BE DECLARED EXTERNAL
C         IN CALLING PROGRAM.  ITS PARAMETER LIST MUST
C         BE (X,F,DERF).
C
C         ON OUTPUT              X
C         RESULTANT ROOT OF EQUATION F(X) = 0.
C
C         F
C         RESULTANT FUNCTION VALUE AT ROOT X.
C
C         DERF
C         RESULTANT VALUE OF DERIVATIVE AT ROOT X.
C
C         IER
C         ERROR FLAG.
C         =  0  NO ERROR.
C         = 32  NO CONVERGENCE AFTER IEND ITERATION
C         STEPS.
C         = 34  DERIVATIVE IS ZERO FOR SOME ITERATION
C         STEP.
C
C         ENTRY POINTS           RTNI
C
C         SPECIAL CONDITIONS     NONE
C
C         COMMON BLOCKS          NONE
C
C         I/O                    NONE
C
C         PRECISION              SINGLE
C
C         REQUIRED ULIB          NONE
C         ROUTINES
C
C         ROUTINES TO BE         FCT
C         PROVIDED BY USER
C         SUBROUTINE FCT (X,F,DERF)
C         THE SUBROUTINE SHOULD EVALUATE
C         F = F(X)
C         DERF = DF(X)/DX
C
C         SPECIALIST             ASTRIK DEIRMENDJIAN, NCAR,
C         BOULDER, COLORADO  80302
C
C         LANGUAGE               FORTRAN
C
C         HISTORY                THIS ROUTINE IS FROM THE IBM SSP LIBRARY.
C
C
C
C
C         PREPARE ITERATION
C
C         THE FOLLOWING CALL IS FOR GATHERING STATISTICS ON LIBRARY USE AT NCAR
C         CALL Q8QST4( 4HNSSL      , 4HRTNI      ,4HRTNI   ,10HVERSION  9)
      IER = 0
      X = XST
      TOL = X
      CALL FCT (TOL,F,DERF)
      TOLF = 100.*EPS
C
C
C         START ITERATION LOOP
C
      DO 60 I=1,IEND
        IF (F) 10,70,10
C
C         EQUATION IS NOT SATISFIED BY X
C
   10   IF (DERF) 20,80,20
C
C         ITERATION IS POSSIBLE
C
   20   DX = F/DERF
        X = X-DX
        TOL = X
        CALL FCT (TOL,F,DERF)
C
C         TEST ON SATISFACTORY ACCURACY
C
        TOL = EPS
        A = ABS(X)
        IF (A-1.) 40,40,30
   30   TOL = TOL*A
   40   IF (ABS(DX)-TOL) 50,50,60
   50   IF (ABS(F)-TOLF) 70,70,60
   60 CONTINUE
C
C         END OF ITERATION LOOP
C
C
C         NO CONVERGENCE AFTER IEND ITERATION STEPS. ERROR RETURN.
C
      IER = 32
   70 RETURN
C
C         ERROR RETURN IN CASE OF ZERO DIVISOR
C
   80 IER = 34
      RETURN
      END
CDECK SOLAR1
      SUBROUTINE SOLAR1(OB,ECC,PER,NY,NT,COSY,SINY,TANY,OMEGA,SOLIRR,
     +COSZ)
C
C         THIS SUBROUTINE COMPUTES THE MEAN DAILY SOLAR IRRADIANCE AT THE
C         TOP OF THE ATMOSPHERE AS A FUNCTION OF LATITUDE AND TIME OF YEAR
C         GIVEN THE OBLIQUITY OF THE EARTH'S AXIS, THE ECCENTRICITY OF THE
C         EARTH'S ORBIT, AND THE ANGLE FROM PERIHELION TO THE VERNAL
C         EQUINOX.
C         COSDEC = COSINE OF THE SOLAR DECLINATION
C         COSY   = COSINES OF THE LATITUDES OF THE GRID POINTS
C         COSZ   = COSINE OF THE MEAN ZENITH ANGLE
C         DT     = TIME STEP SIZE
C         ECC    = ECCENTRICITY OF THE EARTH'S ORBIT
C         E      = INVERSE SQUARED ADJUSTMENT TO THE SOLAR CONSTANT
C         OB     = OBLIQUITY OF THE EARTH'S AXIS
C         OMEGA  = POSITION OF THE EARTH IN ORBIT AS A FUNCTION OF TIME
C         R      = EARTH-SUN DISTANCE
C         SINDEC = SINE OF THE SOLAR DECLINATION
C         SINY   = SINES OF THE LATITUDES OF THE GRID POINTS
C         SOLIRR = SOLAR IRRADIANCE
C         TANDEC = TANGENT OF THE SOLAR DECLINATION
C         TANY   = TANGENTS OF THE LATITUDES OF THE GRID POINTS
C
C         DECLARE THE VARIABLES
C
C         DECLARE THE LOCAL VARIABLES
      INTEGER J,L,NY,NT
      REAL COSDEC,COSY(NY),COSZ(NY,NT),DT,ECC,ECCFAC,E,EZERO,OB,OMEGA
     +(NT),OMGPER,PER,PI,R,SINDEC,SINY(NY),SOLIRR(NY,NT),TANDEC,TANY(NY)
     +,TZERO,T1,T2,T3,T4,Z
C
C         DEFINE STATEMENT FUNCTIONS
C
      ORBFUN(OMEGA1) = RZERO*(1.-(ECC*COS(OMEGA1)))**2
C
C         COMPUTE THE SOLAR IRRADIANCE
C
C         SET NUMERICAL CONSTANTS
      PI = ACOS(-1.0)
      EZERO = 1./PI
      ECCFAC = 1.-ECC**2
      RZERO = 2.*PI/(ECCFAC**1.5)
      SINOB = SIN(OB)
      DT = 1./NT
C
C         ITERATE AROUND THE ORBIT TO FIND THE ANGLE FROM PERIHELION AS
C         A FUNCTION OF TIME
      OMEGA(1) = 0.0
      DO 10 L=2,NT
        OMGPER = OMEGA(L-1)-PER
        T1 = DT*ORBFUN(OMGPER)
        T2 = DT*ORBFUN(OMGPER+(.5*T1))
        T3 = DT*ORBFUN(OMGPER+(.5*T2))
        T4 = DT*ORBFUN(OMGPER+T3)
        OMEGA(L) = OMEGA(L-1)+(1./6.)*(T1+2.*T2+2.*T3+T4)
   10 CONTINUE
C
C         COMPUTE THE SOLAR FLUX AS A FUNCTION OF TIME AND LATITUDE
      DO 30 L=1,NT
        SINDEC = SINOB*SIN(OMEGA(L))
        COSDEC = SQRT(1.-SINDEC**2)
        TANDEC = SINDEC/COSDEC
        R = ECCFAC/(1.-(ECC*COS(OMEGA(L)-PER)))
        E = EZERO/R**2
        DO 20 J=1,NY
          Z = -TANY(J)*TANDEC
          IF (Z.GE.1.) THEN
            SOLIRR(J,L) = 0.
            COSZ(J,L) = 0.
          ELSE
            IF (Z.LE.-1.)  Z = -.999999
            TZERO = ACOS(Z)
            SOLIRR(J,L) = E*((TZERO*SINY(J)*SINDEC)+(COSY(J)*COSDEC*SIN
     +      (TZERO)))
            COSZ(J,L) = PI*SOLIRR(J,L)/TZERO
          ENDIF
   20   CONTINUE
   30 CONTINUE
C
      RETURN
      END
CDECK VELO
      SUBROUTINE VELO(FV)
      PARAMETER (NX1 = 1,NY1 = 16)
      COMMON /PML/QS(NX1,NY1),QH(NX1,NY1),QDS(NX1,NY1),QSB(NX1,NY1),QTB
     +(NX1,NY1),QHB(NX1,NY1),QDT(NX1,NY1),QT(NX1,NY1),UMOLD(NX1,NY1),
     +QHSTO(NX1,NY1),MLFIX,MLMOD,POLY,HS(NX1,NY1),HT(NX1,NY1),WUP 
      DIMENSION FV(5)
      FV(1) = 0.
      FV(2) = 0.
      FV(3) = -WUP
      IF (MLFIX.EQ.1) FV(3) = 0.0
      FV(4) = 0.
      FV(5) = 0.
      RETURN
      END
CDECK WEDDEL
C     PROGRAM WEDDEL(INPUT,OUTPUT,TAPE6=OUTPUT,TAPE7,TAPE8) 
      PARAMETER (NX1 = 1,NY1 = 16)
      DIMENSION TML(NX1,NY1),QFM(NX1,NY1),QHST(NX1,NY1),QV(NX1,NY1)
      DIMENSION QSR(NY1,365),TAIR(31,365),UAIR(31,365)
      DIMENSION TDAT(4,12),UDAT(4,12),MCENT(12),COSY(NY1),SINY(NY1),
     +OMEGA(365),COSZ(NY1,365),TANY(NY1),QFMA(NX1,NY1), 
     +QFMO(NX1,NY1),QFMOO(NX1,NY1),QO(NX1,NY1),QFMOT(NX1,NY1),
     +DHI1(NX1,NY1) 
      DIMENSION TAD(31,12),UAD(31,12),HEAT(NX1,NY1),SALT(NX1,NY1)
      DIMENSION DHID(NX1,NY1),EIS(NY1),UD(NY1)
      DIMENSION LAT(NY1)
      COMMON /PML/QS(NX1,NY1),QH(NX1,NY1),QDS(NX1,NY1),QSB(NX1,NY1),QTB
     +(NX1,NY1),QHB(NX1,NY1),QDT(NX1,NY1),QT(NX1,NY1),UMOLD(NX1,NY1),
     +QHSTO(NX1,NY1),MLFIX,MLMOD,POLY,HS(NX1,NY1),HT(NX1,NY1),WUP 
      REAL JPP,JPL
      COMMON /PAR/ TF(NX1,NY1)
      COMMON /PAR1/ TF1 
      COMMON /STEP/DELTAT,DELTAX,DELTAY
      COMMON /YCEC/ ATEMP,OTEMP,WIND,SOLRAD,CLOUDS,PRESS,HICE
      DATA MCENT/16,45,75,105,136,166,197,228,258,289,319,350/
      DATA TDAT/7.9,2.4,-2.1,-7.9,8.6,2.9,-4.1,-12.4,7.7,0.5,-8.6,-18.6,
     +6.9,-1.4,-11.4,-23.2,5.5,-4.1,-17.4,-28.7,5.2,-3.5,-16.8,-28.9,
     +4.4,-4.8,-19.1,-29.5,4.0,-5.5,-20.3,-32.3,4.6,-4.2,-19.2,-29.6,
     +5.8,-2.4,-14.7,-23.5,6.3,0.0,-7.9,-14.3,7.7,2.0,-3.0,-7.6/
      DATA UDAT/5.4,2.6,-0.2,-0.4,5.5,4.0,1.2,1.2,6.8,4.9,-1.3,1.4,6.9,
     +6.0,1.9,1.5,4.7,4.4,1.4,1.5,5.7,5.9,2.8,0.7,6.9,6.0,1.9,1.6,5.8,
     +3.3,0.1,2.7,5.9,5.8,2.1,1.3,5.8,7.0,3.5,0.9,7.0,5.6,0.7,-0.1,5.6,
     +4.9,0.8,0.8/
      DATA EIS/0.,0.,0.,0.,0.,0.,0.,0.,0.,0.01,0.15,0.19, 
     +0.40,0.46,0.48,0.48/
      DATA UD/5.5,5.4,5.3,5.2,5.1,5.0,4.6,4.2,3.8,3.4,3.0,2.6,
     +2.2,1.7,1.2,0.9/
C 
C     DATA CORRECTION TO GET SINOSOIDAL FORCING 
C     MAY AND JUNE EXCHANGED FOR 60S AND 70S
C     CONSTANT WIND 
C
      OPEN (6,FILE='B:WEDF20.OUT')
      OPEN (7,FILE='B:WEDF20.RES')
      OPEN (8,FILE='B:WEDF20.RST') 
      GO TO 3 
    1 TDAT(2,5)=-3.5
      TDAT(3,5)=-16.8 
      TDAT(2,6)=-4.1
      TDAT(3,6)=-17.4 
      DO 2 I=1,4
      DO 2 J=1,12 
      UDAT(I,J)=5.0 
    2 CONTINUE
C 
C
C
C         SET BASIC PARAMETERS
C          FIXED MIXED LAYER MLFIX=1
C          DECOUPLED RETREAT MLMOD=1
C          OTHERWISE MLFIX=MLMOD=0
C
    3 MLFIX = 0 
      MLMOD=1 
      DELTAT = 86400.0
      DELTAX = 1.25E+05
      DELTAY = 1.25E+05
      NJMAX=20
      TAUMAX = 365.*86400.*FLOAT(NJMAX) 
      NJ = 1
      IFREQ = 10
      CL = 3.02E8
      CC = 4.2E6
C
C
C         NOW INTERPOLATE FORCING DATA (1 DAY, 1 DEG LATITUDE)
C
      DO 10 J=1,12
        DO 10 L=1,31
          IF (L.EQ.31) TAD(L,J) = TDAT(4,J)
          IF (L.EQ.31) UAD(L,J) = UDAT(4,J)
          IF (L.EQ.31) GO TO 10
          I1 = (L-1)/10 + 1
          I1P = I1+1
          JT = MOD(L-1,10)
          TAD(L,J) = TDAT(I1,J)+(TDAT(I1P,J)-TDAT(I1,J))*FLOAT(JT)/10.0
          UAD(L,J) = UDAT(I1,J)+(UDAT(I1P,J)-UDAT(I1,J))*FLOAT(JT)/10.0
   10 CONTINUE
      DO 20 L=1,31
        JINT = 1
        DO 20 ID=1,365
      IF(JINT.EQ.13) GO TO 15 
          IF (ID.EQ.MCENT(JINT)) JINT = JINT+1
   15     I1 = JINT-1 
          I1P = I1+1
          IF (I1.LT.1) I1 = 12
          IF (I1P.GT.12) I1P = 1
          JD = MCENT(I1P)-MCENT(I1)
          IF (I1P.EQ.1) JD = 31
          JT = ID-MCENT(I1)
          IF (ID.LE.15) JT = ID+15
          AJT = FLOAT(JT)/FLOAT(JD)
          TAIR(L,ID) = TAD(L,I1)+(TAD(L,I1P)-TAD(L,I1))*AJT
          UAIR(L,ID) = UAD(L,I1)+(UAD(L,I1P)-UAD(L,I1))*AJT
   20 CONTINUE
C
C         END OF INTERPOLATION
C
C         CALCULATE SOLAR RADIATION QSR
C
   30 PI = 3.14159
      OB = 23.45*PI/180.0
      ECC = 0.0167
      PER = 102.06*PI/180.0
      NT = 365
      DO 40 L=1,NY1
        ALAT = -FLOAT(54+L)
        LAT(L)=ALAT 
        COSY(L) = COS(ALAT*PI/180.0)
        SINY(L) = SIN(ALAT*PI/180.0)
        TANY(L) = SINY(L)/COSY(L)
   40 CONTINUE
      CALL SOLAR1(OB,ECC,PER,NY1,NT,COSY,SINY,TANY,OMEGA,QSR,COSZ)
C
C
C
C         SET INITIAL CONDITIONS FOR HEATCONTENT/ICE THICKNESS
C
      DO 50 I=1,NX1
        DO 50 J=1,NY1
          QHST(I,J) =EIS(J) 
      DHID(I,J)=0.
      QFMA(I,J)=0.
      QFMO(I,J)=0.
      QFMOO(I,J)=0. 
      QFMOT(I,J)=0. 
   50 CONTINUE
C
      CALL BOUND(QHST)
C 
C... RESTART FROM FILE STARTW 
C 
      IF(MLFIX.EQ.1) GO TO 55 
C     READ(8,997) (QT(1,J),QS(1,J),QH(1,J),QDT(1,J),QDS(1,J), 
C    1  QHST(1,J),QTB(1,J),QSB(1,J),HT(1,J),HS(1,J),J=1,NY1)
C     REWIND 8
      DO 52 I=1,NX1 
      DO 52 J=1,NY1 
      QHSTO(I,J)=QHST(I,J)
   52 CONTINUE
C
   55 TAU = 0.0 
      ICOUNT = 0
   60 ICOUNT = ICOUNT+1
      TAU = TAU+DELTAT
      DAY = TAU/86400.
      IDAY=INT(DAY+0.5) 
      NJ = INT((DAY-0.5)/365.0)+1
      ITAU = INT(DAY+0.5)-(NJ-1)*365
C 
      POLY=0
C     IF(NJ.NE.2)GO TO 65 
C     IF(ITAU.GE.135.AND.ITAU.LE.155) POLY=1.0
C  65 IF(POLY.EQ.0.) QTB(1,12)=0.6
C     HT(1,12)=(QT(1,12)-QTB(1,12))*(QH(1,12)+QDT(1,12))
C    1+QTB(1,12)*QHB(1,12)
C 
      DO 70 J=1,NY1 
        DO 70 I=1,NX1 
          JDAT = J+5
C
C         FLUCTUATING ICE VELOCITY CUBED IN (M/S)**3
C
          STD = 0.0
          IF (MOD(ITAU,2).EQ.0) ZIG = 1.
          IF (MOD(ITAU,4).EQ.1) ZIG = 1.-STD
          IF (MOD(ITAU,4).EQ.3) ZIG = 1.+STD
          QV(I,J) =(0.16*ZIG)**3
C         IF(QHST(I,J).GE.0.0) QV(I,J)=0.5*(0.1*ZIG)**3 
C
C
C         UPDATE HEATCONTENT/ICE THICKNESS
C         DUE TO ATMOSPHERIC HEATFLUXES FM (M ICE/SEC)
C
          QO(I,J) = QHST(I,J) 
          ATEMP = TAIR(JDAT,ITAU)+273.16
C     ATEMP=ATEMP+2.0 
          OTEMP = QT(I,J)+273.16
          WIND = ABS(UAIR(JDAT,ITAU))
C     WIND=UD(J)
          ITAUR = ITAU-79
          IF (ITAUR.LE.0) ITAUR = ITAU+286
          SOLRAD = QSR(J,ITAUR)*1376.0
C     SOLRAD=SOLRAD*0.9 
          CLOUDS = 0.5
          IF (ITAU.GE.120.AND.ITAU.LE.290) CLOUDS = 0.7
          PRESS = 98800.0
          HICE = QHST(I,J)
      TF(I,J)=-0.0575*QS(I,J)+1.710523E-3*QS(I,J)**1.5
     1-2.154996E-4*QS(I,J)**2.0 
C     TF(I,J)=-1.96 
      TF1=TF(I,J) 
          CALL YCEGRO(DHI)
          QHST(I,J) = QHST(I,J)+DELTAT*DHI
      DHI1(I,J)=DHI*DELTAT
          DHID(I,J) =DHID(I,J)+ DHI *DELTAT 
C
C         SET SURFACE FLUXES (MELTRATE IN M OF ICE/TIMESTEP)
C
          QFM(I,J) = AMAX1(QO(I,J),0.)-AMAX1(QHST(I,J),0.)
      IF(DAY.LT.3.5) QFM(I,J)=0.0 
          QFMA(I,J)=QFMA(I,J)+QFM(I,J)
C
   70 CONTINUE
C
      CALL PML1(QHST,QFM,QV,TML)
C
C
C 
      DO 80 J=1,NY1 
        DO 80 I=1,NX1 
      QFMO(I,J)=QFMO(I,J)+QFM(I,J)
      QFMOT(I,J)=QFMOT(I,J)+QHST(I,J)-QO(I,J) 
      QFMOO(I,J)=QFMOO(I,J)+QHST(I,J)-QO(I,J)-DHI1(I,J) 
   80 CONTINUE
C 
C    STORE RESULTS
C 
      IF(NJ.GE.NJMAX-3) 
     1WRITE(7,999) (QT(1,J),QS(1,J),QH(1,J),QDT(1,J),QDS(1,J),
     1              QHST(1,J),DHID(1,J),QFMA(1,J),QFMO(1,J),
     2              QFMOO(1,J),HT(1,J),HS(1,J),J=1,NY1) 
  999 FORMAT(1H ,2F6.2,3F6.1,F6.2,4F6.2,2F9.1,1H )
C
C
C         PRINT PROFILE PARAMETERS WHEN APPROPRIATE
C
      IF (ICOUNT.NE.IFREQ) GO TO  90
      ICOUNT = 0
      IF(NJ.LT.NJMAX-3)GO TO 90 
      WRITE(6,100) DAY,ITAU,NJ
      WRITE(6,992) (LAT(J),J=1,NY1) 
C     WRITE(6,120) (TAIR(J+5,ITAU),J = 1,NY1) 
C     WRITE(6,120) (UAIR(J+5,ITAU),J = 1,NY1) 
C     WRITE(6,120) (UD(J),J = 1,NY1)
C     WRITE(6,120) (QSR(J,ITAUR)*100.,J = 1,NY1)
      WRITE(6,120) (QT(1,J),J = 1,NY1)
      WRITE(6,120) (QS(1,J),J = 1,NY1)
      WRITE(6,120) (QH(1,J),J = 1,NY1)
      WRITE(6,120) (QDT(1,J),J = 1,NY1) 
      WRITE(6,120) (QDS(1,J),J = 1,NY1) 
      WRITE(6,120) (QTB(1,J),J = 1,NY1) 
      WRITE(6,120) (QSB(1,J),J = 1,NY1) 
      WRITE(6,120) (QHST(1,J),J = 1,NY1)
      WRITE(6,110)
      WRITE(6,125) (DHID(1,J),J=1,NY1)
      WRITE(6,125) (QFMA(1,J),J=1,NY1)
      WRITE(6,125) (QFMO(1,J),J=1,NY1)
      WRITE(6,125) (QFMOO(1,J),J=1,NY1) 
      WRITE(6,125) (QFMOT(1,J),J=1,NY1) 
      WRITE(6,991) (HT(1,J),J=1,NY1)
      WRITE(6,991) (HS(1,J),J=1,NY1)
      WRITE(6,110)
      DO 89 J1=1,NX1
      DO 89 J2=1,NY1
      QFMA(J1,J2)=0.
      QFMO(J1,J2)=0.
      QFMOO(J1,J2)=0. 
      DHID(J1,J2)=0.
      QFMOT(J1,J2)=0. 
   89 CONTINUE
   90 IF (TAU-TAUMAX) 60,130,130
  130 CONTINUE
      REWIND 8
      IF(MLFIX.NE.1)
     1WRITE(8,997) (QT(1,J),QS(1,J),QH(1,J),QDT(1,J),QDS(1,J),
     1  QHST(1,J),QTB(1,J),QSB(1,J),HT(1,J),HS(1,J),J=1,NY1)
  997 FORMAT(8F10.4,2F14.5) 
C 
C 
  100 FORMAT(1H ,F10.1,2I7)
  110 FORMAT(1H0)
  120 FORMAT(1H ,16F7.2)
  125 FORMAT(1H ,16F7.3)
  991 FORMAT(1H ,16F8.1)
  992 FORMAT(1H ,16I7)
C
C
      STOP
      END
CDECK YCEGRO
      SUBROUTINE YCEGRO(DHI)
C
C         CALCULATES ICE GROWTH IN M/S
C
      COMMON /YCEC/ ATEMP,OTEMP,WIND,SOLRAD,CLOUDS,PRESS,HICE
      EXTERNAL ENBALI
      ELF = 3.02E8
      TS = OTEMP
      IF (HICE.LE.0.0) GO TO 10
      IEND = 1000
      EPSR = 1.0E-4
      TSO = 255.0
      CALL RTNI(TS,FTS,DERF,ENBALI,TSO,EPSR,IEND,IER)
      IF (TS.GT.273.16) TS = 273.16
   10 DHI = -(RAD(TS)+FSL(TS))/ELF
      RETURN
      END